(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var _ = Package.underscore._;
var Random = Package.random.Random;
var ReactiveVar = Package['reactive-var'].ReactiveVar;
var SandstormDb = Package['sandstorm-db'].SandstormDb;
var SandstormBackend = Package['sandstorm-backend'].SandstormBackend;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Accounts = Package['accounts-base'].Accounts;
var check = Package.check.check;
var Match = Package.check.Match;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

var require = meteorInstall({"node_modules":{"meteor":{"accounts-identity":{"accounts-identity-server.js":function(){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/accounts-identity/accounts-identity-server.js                                                             //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
// Sandstorm - Personal Cloud Sandbox                                                                                 //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                              //
// All rights reserved.                                                                                               //
//                                                                                                                    //
// Licensed under the Apache License, Version 2.0 (the "License");                                                    //
// you may not use this file except in compliance with the License.                                                   //
// You may obtain a copy of the License at                                                                            //
//                                                                                                                    //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       //
//                                                                                                                    //
// Unless required by applicable law or agreed to in writing, software                                                //
// distributed under the License is distributed on an "AS IS" BASIS,                                                  //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           //
// See the License for the specific language governing permissions and                                                //
// limitations under the License.                                                                                     //
                                                                                                                      //
function linkIdentityToAccountInternal(db, backend, identityId, accountId) {                                          // 17
  // Links the identity to the account and grants it login access if possible. Makes the account                      //
  // durable if it is a demo account.                                                                                 //
                                                                                                                      //
  check(db, SandstormDb);                                                                                             // 21
  check(backend, SandstormBackend);                                                                                   // 22
  check(identityId, String);                                                                                          // 23
  check(accountId, String);                                                                                           // 24
                                                                                                                      //
  var accountUser = Meteor.users.findOne({ _id: accountId });                                                         // 26
  if (!accountUser) {                                                                                                 // 27
    throw new Meteor.Error(404, "No account found with ID " + accountId);                                             // 28
  }                                                                                                                   //
                                                                                                                      //
  if (accountUser.profile) {                                                                                          // 31
    throw new Meteor.Error(400, "Cannot link an identity to another identity.");                                      // 32
  }                                                                                                                   //
                                                                                                                      //
  if (!!_.findWhere(accountUser.loginIdentities, { id: identityId }) || !!_.findWhere(accountUser.nonloginIdentities, { id: identityId })) {
    throw new Meteor.Error("alreadyLinked", "Cannot link an identity that's alread linked to this account.");         // 37
  }                                                                                                                   //
                                                                                                                      //
  var identityUser = Meteor.users.findOne({ _id: identityId });                                                       // 41
                                                                                                                      //
  if (!identityUser) {                                                                                                // 43
    throw new Meteor.Error(404, "No identity found with ID " + identityId);                                           // 44
  }                                                                                                                   //
                                                                                                                      //
  if (!identityUser.profile) {                                                                                        // 47
    throw new Meteor.Error(400, "Cannot link an account to another account");                                         // 48
  }                                                                                                                   //
                                                                                                                      //
  db.deleteUnusedAccount(backend, identityUser._id);                                                                  // 51
  if (Meteor.users.findOne({ "loginIdentities.id": identityUser._id })) {                                             // 52
    throw new Meteor.Error(403, "Cannot link an identity that can already log into another account");                 // 53
  }                                                                                                                   //
                                                                                                                      //
  var alreadyLinked = !!Meteor.users.findOne({ "nonloginIdentities.id": identityUser._id });                          // 57
                                                                                                                      //
  var pushModifier = alreadyLinked ? { nonloginIdentities: { id: identityUser._id } } : { loginIdentities: { id: identityUser._id } };
                                                                                                                      //
  var modifier = void 0;                                                                                              // 63
  if (accountUser.expires) {                                                                                          // 64
    if (alreadyLinked) {                                                                                              // 65
      throw new Meteor.Error(403, "Cannot create an account for an identity that's " + "already linked to another account.");
    }                                                                                                                 //
                                                                                                                      //
    modifier = {                                                                                                      // 70
      $push: pushModifier,                                                                                            // 71
      $unset: { expires: 1 },                                                                                         // 72
      $set: { upgradedFromDemo: Date.now() }                                                                          // 73
    };                                                                                                                //
    if (Meteor.settings["public"].quotaEnabled) {                                                                     // 75
      // Demo users never got the referral notification. Send it now:                                                 //
      db.sendReferralProgramNotification(accountUser._id);                                                            // 77
    }                                                                                                                 //
  } else {                                                                                                            //
    modifier = { $push: pushModifier };                                                                               // 81
  }                                                                                                                   //
                                                                                                                      //
  // Make sure not to add the same identity twice.                                                                    //
  Meteor.users.update({ _id: accountUser._id,                                                                         // 17
    "nonloginIdentities.id": { $ne: identityUser._id },                                                               // 86
    "loginIdentities.id": { $ne: identityUser._id } }, modifier);                                                     // 87
                                                                                                                      //
  if (accountUser.expires) {                                                                                          // 90
    var demoIdentityId = SandstormDb.getUserIdentityIds(accountUser)[0];                                              // 91
    Meteor.users.update({ _id: demoIdentityId }, { $unset: { expires: 1 },                                            // 92
      $set: { upgradedFromDemo: Date.now() } });                                                                      // 94
                                                                                                                      //
    // Mark the demo identity as nonlogin. It'd be nicer if the identity started out as nonlogin,                     //
    // but to get that to work we would need to adjust the account creation and first login logic.                    //
    Meteor.users.update({ _id: accountUser._id,                                                                       // 90
      "loginIdentities.id": demoIdentityId,                                                                           // 99
      "nonloginIdentities.id": { $not: { $eq: demoIdentityId } } }, { $pull: { loginIdentities: { id: demoIdentityId } },
      $push: { nonloginIdentities: { id: demoIdentityId } } });                                                       // 102
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
Meteor.methods({                                                                                                      // 107
  loginWithIdentity: function () {                                                                                    // 108
    function loginWithIdentity(accountUserId) {                                                                       // 108
      // Logs into the account with ID `accountUserId`. Throws an exception if the current user is                    //
      // not an identity user listed in the account's `loginIdentities` field. This method is not                     //
      // intended to be called directly; client-side code should only invoke it through                               //
      // `Meteor.loginWithIdentity()`, which additionally maintains the standard Meteor client-side                   //
      // login state.                                                                                                 //
                                                                                                                      //
      check(accountUserId, String);                                                                                   // 115
                                                                                                                      //
      var identityUser = Meteor.user();                                                                               // 117
      if (!identityUser || !identityUser.profile) {                                                                   // 118
        throw new Meteor.Error(403, "Must be already logged in as an identity.");                                     // 119
      }                                                                                                               //
                                                                                                                      //
      var accountUser = Meteor.users.findOne(accountUserId);                                                          // 122
      if (!accountUser) {                                                                                             // 123
        throw new Meteor.Error(404, "No such user found: " + accountUserId);                                          // 124
      }                                                                                                               //
                                                                                                                      //
      var linkedIdentity = _.findWhere(accountUser.loginIdentities, { id: identityUser._id });                        // 127
                                                                                                                      //
      if (!linkedIdentity) {                                                                                          // 129
        throw new Meteor.Error(403, "Current identity is not a login identity for account " + accountUserId);         // 130
      }                                                                                                               //
                                                                                                                      //
      return Accounts._loginMethod(this, "loginWithIdentity", [accountUserId], "identity", function () {              // 134
        return { userId: accountUserId };                                                                             // 135
      });                                                                                                             //
    }                                                                                                                 //
                                                                                                                      //
    return loginWithIdentity;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  createAccountForIdentity: function () {                                                                             // 138
    function createAccountForIdentity() {                                                                             // 138
      // Creates a new account for the currently-logged-in identity.                                                  //
                                                                                                                      //
      var user = Meteor.user();                                                                                       // 141
      if (!(user && user.profile)) {                                                                                  // 142
        throw new Meteor.Error(403, "Must be logged in as an identity in order to create an account.");               // 143
      }                                                                                                               //
                                                                                                                      //
      if (Meteor.users.findOne({                                                                                      // 146
        $or: [{ "loginIdentities.id": user._id }, { "nonloginIdentities.id": user._id }]                              // 147
      })) {                                                                                                           //
        throw new Meteor.Error(403, "Cannot create an account for an identity that's already " + "linked to another account.");
      }                                                                                                               //
                                                                                                                      //
      var newUser = {                                                                                                 // 156
        loginIdentities: [{ id: user._id }],                                                                          // 157
        nonloginIdentities: []                                                                                        // 158
      };                                                                                                              //
      if (user.services.dev) {                                                                                        // 160
        newUser.signupKey = "devAccounts";                                                                            // 161
        if (user.services.dev.isAdmin) {                                                                              // 162
          newUser.isAdmin = true;                                                                                     // 163
        }                                                                                                             //
                                                                                                                      //
        if (user.services.dev.hasCompletedSignup) {                                                                   // 166
          newUser.hasCompletedSignup = true;                                                                          // 167
        }                                                                                                             //
      } else if (user.expires) {                                                                                      //
        // Demo user.                                                                                                 //
        newUser.expires = user.expires;                                                                               // 171
        if (!!user.appDemoId) {                                                                                       // 172
          newUser.appDemoId = user.appDemoId;                                                                         // 173
        }                                                                                                             //
      }                                                                                                               //
                                                                                                                      //
      var options = {};                                                                                               // 177
                                                                                                                      //
      // This will throw an error if the identity has been added as a login identity to some                          //
      // other account while we were executing the body of this method.                                               //
      return Accounts.insertUserDoc(options, newUser);                                                                // 138
    }                                                                                                                 //
                                                                                                                      //
    return createAccountForIdentity;                                                                                  //
  }(),                                                                                                                //
                                                                                                                      //
  linkIdentityToAccount: function () {                                                                                // 184
    function linkIdentityToAccount(token) {                                                                           // 184
      // Links the identity of the current user to the account that has `token` as a resume token.                    //
      // If the account is a demo account, makes the account durable and gives the identity login                     //
      // access to it.                                                                                                //
                                                                                                                      //
      check(token, String);                                                                                           // 189
                                                                                                                      //
      if (!this.userId) {                                                                                             // 191
        throw new Meteor.Error(403, "Cannot link to account if not logged in.");                                      // 192
      }                                                                                                               //
                                                                                                                      //
      var hashed = Accounts._hashLoginToken(token);                                                                   // 195
      var accountUser = Meteor.users.findOne({ "services.resume.loginTokens.hashedToken": hashed });                  // 196
                                                                                                                      //
      linkIdentityToAccountInternal(this.connection.sandstormDb, this.connection.sandstormBackend, this.userId, accountUser._id);
    }                                                                                                                 //
                                                                                                                      //
    return linkIdentityToAccount;                                                                                     //
  }(),                                                                                                                //
                                                                                                                      //
  unlinkIdentity: function () {                                                                                       // 202
    function unlinkIdentity(accountUserId, identityId) {                                                              // 202
      // Unlinks the identity with ID `identityId` from the account with ID `accountUserId`.                          //
                                                                                                                      //
      check(identityId, String);                                                                                      // 205
      check(accountUserId, String);                                                                                   // 206
                                                                                                                      //
      if (!this.userId) {                                                                                             // 208
        throw new Meteor.Error(403, "Not logged in.");                                                                // 209
      }                                                                                                               //
                                                                                                                      //
      if (!this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                                    // 212
        throw new Meteor.Error(403, "Current user does not own identity " + identityId);                              // 213
      }                                                                                                               //
                                                                                                                      //
      var identityUser = Meteor.users.findOne({ _id: identityId });                                                   // 216
      Meteor.users.update({                                                                                           // 217
        _id: accountUserId                                                                                            // 218
      }, {                                                                                                            //
        $pull: {                                                                                                      // 220
          nonloginIdentities: { id: identityId },                                                                     // 221
          loginIdentities: { id: identityId }                                                                         // 222
        }                                                                                                             //
      });                                                                                                             //
    }                                                                                                                 //
                                                                                                                      //
    return unlinkIdentity;                                                                                            //
  }(),                                                                                                                //
                                                                                                                      //
  setIdentityAllowsLogin: function () {                                                                               // 227
    function setIdentityAllowsLogin(identityId, allowLogin) {                                                         // 227
      // Sets whether the current account allows the identity with ID `identityId` to log in.                         //
                                                                                                                      //
      check(identityId, String);                                                                                      // 230
      check(allowLogin, Boolean);                                                                                     // 231
      if (!this.userId) {                                                                                             // 232
        throw new Meteor.Error(403, "Not logged in.");                                                                // 233
      }                                                                                                               //
                                                                                                                      //
      if (!this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                                    // 236
        throw new Meteor.Error(403, "Current user does not own identity " + identityId);                              // 237
      }                                                                                                               //
                                                                                                                      //
      if (allowLogin) {                                                                                               // 240
        Meteor.users.update({ _id: this.userId,                                                                       // 241
          "nonloginIdentities.id": identityId,                                                                        // 242
          "loginIdentities.id": { $not: { $eq: identityId } } }, { $pull: { nonloginIdentities: { id: identityId } },
          $push: { loginIdentities: { id: identityId } } });                                                          // 245
      } else {                                                                                                        //
        Meteor.users.update({ _id: this.userId,                                                                       // 247
          "loginIdentities.id": identityId,                                                                           // 248
          "nonloginIdentities.id": { $not: { $eq: identityId } } }, { $pull: { loginIdentities: { id: identityId } },
          $push: { nonloginIdentities: { id: identityId } } });                                                       // 251
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return setIdentityAllowsLogin;                                                                                    //
  }(),                                                                                                                //
                                                                                                                      //
  logoutIdentitiesOfCurrentAccount: function () {                                                                     // 255
    function logoutIdentitiesOfCurrentAccount() {                                                                     // 255
      // Logs out all identities that are allowed to log in to the current account.                                   //
      var user = Meteor.user();                                                                                       // 257
      if (user && user.loginIdentities) {                                                                             // 258
        user.loginIdentities.forEach(function (identity) {                                                            // 259
          Meteor.users.update({ _id: identity.id }, { $set: { "services.resume.loginTokens": [] } });                 // 260
        });                                                                                                           //
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return logoutIdentitiesOfCurrentAccount;                                                                          //
  }()                                                                                                                 //
});                                                                                                                   //
                                                                                                                      //
Accounts.linkIdentityToAccount = function (db, backend, identityId, accountId) {                                      // 266
  // Links the identity to the account. If the account is a demo account, makes it durable and                        //
  // gives the identity login access to it.                                                                           //
  check(db, SandstormDb);                                                                                             // 269
  check(backend, SandstormBackend);                                                                                   // 270
  check(identityId, String);                                                                                          // 271
  check(accountId, String);                                                                                           // 272
  linkIdentityToAccountInternal(db, backend, identityId, accountId);                                                  // 273
};                                                                                                                    //
                                                                                                                      //
Meteor.publish("accountsOfIdentity", function (identityId) {                                                          // 276
  check(identityId, String);                                                                                          // 277
  if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                             // 278
                                                                                                                      //
  // We maintain a map from identity IDs to live query handles that track profile changes.                            //
  var loginIdentities = {};                                                                                           // 276
                                                                                                                      //
  var _this = this;                                                                                                   // 283
  function addIdentitiesOfAccount(account) {                                                                          // 284
    account.loginIdentities.forEach(function (identity) {                                                             // 285
      if (!(identity.id in loginIdentities)) {                                                                        // 286
        var user = Meteor.users.findOne({ _id: identity.id });                                                        // 287
        if (user) {                                                                                                   // 288
          SandstormDb.fillInProfileDefaults(user);                                                                    // 289
          SandstormDb.fillInIntrinsicName(user);                                                                      // 290
          SandstormDb.fillInLoginId(user);                                                                            // 291
          var filteredUser = _.pick(user, "_id", "profile", "loginId");                                               // 292
          filteredUser.loginAccountId = account._id;                                                                  // 293
          filteredUser.sourceIdentityId = identityId;                                                                 // 294
          _this.added("loginIdentitiesOfLinkedAccounts", user._id, filteredUser);                                     // 295
        }                                                                                                             //
                                                                                                                      //
        loginIdentities[identity.id] = Meteor.users.find({ _id: identity.id }, { fields: { profile: 1 } }).observeChanges({
          changed: function () {                                                                                      // 300
            function changed(id, fields) {                                                                            // 300
              _this.changed("loginIdentitiesOfLinkedAccounts", id, fields);                                           // 301
            }                                                                                                         //
                                                                                                                      //
            return changed;                                                                                           //
          }()                                                                                                         //
        });                                                                                                           //
      }                                                                                                               //
    });                                                                                                               //
  }                                                                                                                   //
                                                                                                                      //
  var cursor = Meteor.users.find({                                                                                    // 308
    $or: [{ "loginIdentities.id": identityId }, { "nonloginIdentities.id": identityId }]                              // 309
  });                                                                                                                 //
                                                                                                                      //
  var handle = cursor.observe({                                                                                       // 315
    added: function () {                                                                                              // 316
      function added(account) {                                                                                       // 316
        addIdentitiesOfAccount(account);                                                                              // 317
      }                                                                                                               //
                                                                                                                      //
      return added;                                                                                                   //
    }(),                                                                                                              //
                                                                                                                      //
    changed: function () {                                                                                            // 320
      function changed(newAccount, oldAccount) {                                                                      // 320
        addIdentitiesOfAccount(newAccount);                                                                           // 321
      }                                                                                                               //
                                                                                                                      //
      return changed;                                                                                                 //
    }(),                                                                                                              //
                                                                                                                      //
    removed: function () {                                                                                            // 324
      function removed(account) {                                                                                     // 324
        account.loginIdentities.forEach(function (identity) {                                                         // 325
          if (identity.id in loginIdentities) {                                                                       // 326
            self.removed("loginIdentitiesOfLinkedAccounts", identity.id);                                             // 327
            loginIdentities[identity.id].stop();                                                                      // 328
            delete loginIdentities[identity.id];                                                                      // 329
          }                                                                                                           //
        });                                                                                                           //
      }                                                                                                               //
                                                                                                                      //
      return removed;                                                                                                 //
    }()                                                                                                               //
  });                                                                                                                 //
  this.ready();                                                                                                       // 334
                                                                                                                      //
  this.onStop(function () {                                                                                           // 336
    handle.stop();                                                                                                    // 337
    Object.keys(loginIdentities).forEach(function (identityId) {                                                      // 338
      loginIdentities[identityId].stop();                                                                             // 339
      delete loginIdentities[identityId];                                                                             // 340
    });                                                                                                               //
  });                                                                                                                 //
});                                                                                                                   //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/accounts-identity/accounts-identity-server.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['accounts-identity'] = {};

})();

//# sourceMappingURL=accounts-identity.js.map
