(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var Random = Package.random.Random;
var _ = Package.underscore._;
var SandstormDb = Package['sandstorm-db'].SandstormDb;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var SandstormPermissions, path;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-permissions":{"permissions.js":["babel-runtime/helpers/typeof","babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-permissions/permissions.js                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
SandstormPermissions = {};                                                                                             // 19
                                                                                                                       //
var PermissionSet = function () {                                                                                      //
  // A wrapper around an array of booleans representing a set of permissions like "read" or                            //
  // "write". This might represent the permissions held by some user on some grain, or it might                        //
  // represent the permissions that one user has chosen to share with another user.                                    //
  //                                                                                                                   //
  // In our model, permissions are independent. You can have "read" without "write" and you can                        //
  // have "write" without "read". Many apps don't actually allow arbitrary permutations, and                           //
  // instead define "roles" like "editor" or "viewer", where "editor" implies both read and write                      //
  // permission while "viewer" implies only read. Roles, however, are just aliases for sets of                         //
  // permissions; all actual computation is done on permissions.                                                       //
                                                                                                                       //
  function PermissionSet(array) {                                                                                      // 32
    (0, _classCallCheck3["default"])(this, PermissionSet);                                                             //
                                                                                                                       //
    if (!array) {                                                                                                      // 33
      this.array = [];                                                                                                 // 34
    } else if (array instanceof Array) {                                                                               //
      this.array = array.slice(0);                                                                                     // 36
    } else {                                                                                                           //
      throw new Error("don't know how to interpret as PermissionSet: " + array);                                       // 38
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  PermissionSet.fromRoleAssignment = function () {                                                                     // 21
    function fromRoleAssignment(roleAssignment, viewInfo) {                                                            //
      // Create a PermissionSet based on a ViewSharingLink.RoleAssignment and a UiView.ViewInfo (as                    //
      // defined in grain.capnp). ViewInfo defines a mapping from roles to permission sets for a                       //
      // particular grain type. RoleAssignment represents the permissions passed from one user to                      //
      // another -- usually it specifies a single role, but sometimes also specifies permissions to                    //
      // add or remove as well.                                                                                        //
      //                                                                                                               //
      // A falsy value for `roleAssignment` is considered equivalent to a "none" value, which means                    //
      // that no role was explicitly chosen, so the default role should be assigned.                                   //
                                                                                                                       //
      var result = new PermissionSet([]);                                                                              // 52
                                                                                                                       //
      if (!roleAssignment || "none" in roleAssignment) {                                                               // 54
        // No role explicitly chosen, e.g. because the app did not define any roles at the time                        //
        // the sharing took place. Assign the default role, if there is one.                                           //
                                                                                                                       //
        if (viewInfo.roles) {                                                                                          // 58
          for (var ii = 0; ii < viewInfo.roles.length; ++ii) {                                                         // 59
            var roleDef = viewInfo.roles[ii];                                                                          // 60
            if (roleDef["default"]) {                                                                                  // 61
              result = new PermissionSet(roleDef.permissions);                                                         // 62
              break;                                                                                                   // 63
            }                                                                                                          //
          }                                                                                                            //
        }                                                                                                              //
      } else if ("allAccess" in roleAssignment) {                                                                      //
        // All permissions are shared, even if there is no explicitly-defined role for this.                           //
                                                                                                                       //
        var length = 0;                                                                                                // 70
        if (viewInfo.permissions) {                                                                                    // 71
          length = viewInfo.permissions.length;                                                                        // 72
        }                                                                                                              //
                                                                                                                       //
        var array = new Array(length);                                                                                 // 75
        for (var _ii = 0; _ii < array.length; ++_ii) {                                                                 // 76
          array[_ii] = true;                                                                                           // 77
        }                                                                                                              //
                                                                                                                       //
        result = new PermissionSet(array);                                                                             // 80
      } else if ("roleId" in roleAssignment && viewInfo.roles && viewInfo.roles.length > 0) {                          //
        // A specific role was chosen.                                                                                 //
                                                                                                                       //
        var _roleDef = viewInfo.roles[roleAssignment.roleId];                                                          // 84
        if (_roleDef) {                                                                                                // 85
          result = new PermissionSet(_roleDef.permissions);                                                            // 86
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      if (roleAssignment) {                                                                                            // 90
        // Add or remove specific permissions. This is uncommon.                                                       //
        result.add(new PermissionSet(roleAssignment.addPermissionSet));                                                // 92
        result.remove(new PermissionSet(roleAssignment.removePermissionSet));                                          // 93
      }                                                                                                                //
                                                                                                                       //
      return result;                                                                                                   // 96
    }                                                                                                                  //
                                                                                                                       //
    return fromRoleAssignment;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  PermissionSet.prototype.isEmpty = function () {                                                                      // 21
    function isEmpty() {                                                                                               //
      var result = true;                                                                                               // 100
      this.array.forEach(function (p) {                                                                                // 101
        if (p) {                                                                                                       // 102
          result = false;                                                                                              // 103
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      return result;                                                                                                   // 107
    }                                                                                                                  //
                                                                                                                       //
    return isEmpty;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  PermissionSet.prototype.isSubsetOf = function () {                                                                   // 21
    function isSubsetOf(other) {                                                                                       //
      check(other, PermissionSet);                                                                                     // 111
      for (var ii = 0; ii < this.array.length; ++ii) {                                                                 // 112
        var mine = this.array[ii];                                                                                     // 113
        var yours = other.array[ii] || false;                                                                          // 114
        if (mine && !yours) {                                                                                          // 115
          return false;                                                                                                // 116
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return true;                                                                                                     // 120
    }                                                                                                                  //
                                                                                                                       //
    return isSubsetOf;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  // Methods for mutating a PermissionSet by combining it with another PermissionSet.                                  //
  // These return a boolean indicating whether the operation had any effect.                                           //
                                                                                                                       //
  PermissionSet.prototype.add = function () {                                                                          // 21
    function add(other) {                                                                                              //
      check(other, PermissionSet);                                                                                     // 127
      var changed = false;                                                                                             // 128
      for (var ii = 0; ii < other.array.length; ++ii) {                                                                // 129
        var old = !!this.array[ii];                                                                                    // 130
        this.array[ii] = !!this.array[ii] || other.array[ii];                                                          // 131
        if (old !== this.array[ii]) {                                                                                  // 132
          changed = true;                                                                                              // 133
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  // 137
    }                                                                                                                  //
                                                                                                                       //
    return add;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  PermissionSet.prototype.remove = function () {                                                                       // 21
    function remove(other) {                                                                                           //
      check(other, PermissionSet);                                                                                     // 141
      var changed = false;                                                                                             // 142
      for (var ii = 0; ii < other.array.length && ii < this.array.length; ++ii) {                                      // 143
        var old = !!this.array[ii];                                                                                    // 144
        this.array[ii] = !!this.array[ii] && !other.array[ii];                                                         // 145
        if (old !== this.array[ii]) {                                                                                  // 146
          changed = true;                                                                                              // 147
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  // 151
    }                                                                                                                  //
                                                                                                                       //
    return remove;                                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  PermissionSet.prototype.intersect = function () {                                                                    // 21
    function intersect(other) {                                                                                        //
      check(other, PermissionSet);                                                                                     // 155
      var changed = false;                                                                                             // 156
      for (var ii = 0; ii < this.array.length; ++ii) {                                                                 // 157
        var old = !!this.array[ii];                                                                                    // 158
        this.array[ii] = !!this.array[ii] && other.array[ii];                                                          // 159
        if (old !== this.array[ii]) {                                                                                  // 160
          changed = true;                                                                                              // 161
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  // 165
    }                                                                                                                  //
                                                                                                                       //
    return intersect;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  return PermissionSet;                                                                                                //
}();                                                                                                                   //
                                                                                                                       //
var RequirementSet = function () {                                                                                     //
  // A conjunction of permissions for identities on grains.                                                            //
  //                                                                                                                   //
  // This typically represents a set of `MembraneRequirement`s, as defined in `supervisor.capnp`.                      //
  // These represent conditions under which some connection formed between grains remains valid.                       //
  // When a capability travels from grain to grain, it passes across these connections -- if any                       //
  // of the connections becomes invalid (is revoked), then the capability must be revoked as well.                     //
  // The word "membrane" comes from the concept of revokable membranes; the capability is passing                      //
  // across such membranes as it travels.                                                                              //
  //                                                                                                                   //
  // For example, a RequirementSet might represent the statement "Alice has read access to Foo, Bob                    //
  // has write access to Foo, and Bob has read access to Bar". Specifically, this example situation                    //
  // would come about if:                                                                                              //
  // - Bob used his read access to Bar to extract a capability from it.                                                //
  // - Bob embedded that capability into Foo, using his write access.                                                  //
  // - Alice extracted the capability from Foo, using her read access.                                                 //
  // If any of these permissions are revoked, then the capability needs to be revoked as well.                         //
                                                                                                                       //
  function RequirementSet() {                                                                                          // 187
    (0, _classCallCheck3["default"])(this, RequirementSet);                                                            //
                                                                                                                       //
    this.permissionsHeldRequirements = {};                                                                             // 188
    // Two-level map. Maps a pair of a grain ID and an identity ID to a PermissionSet.                                 //
                                                                                                                       //
    this.userIsAdminRequirements = {};                                                                                 // 187
    // Map from account ID to boolean. Represents a set of `userIsAdmin` requirements.                                 //
                                                                                                                       //
    this.tokenValidRequirements = {};                                                                                  // 187
    // Map from token ID to boolean. Represents a set of `tokenValid` requirements.                                    //
  }                                                                                                                    // 187
                                                                                                                       //
  RequirementSet.prototype.isEmpty = function () {                                                                     // 169
    function isEmpty() {                                                                                               //
      for (var tokenId in meteorBabelHelpers.sanitizeForInObject(this.tokenValidRequirements)) {                       // 199
        return false;                                                                                                  // 200
      }                                                                                                                //
                                                                                                                       //
      for (var grainId in meteorBabelHelpers.sanitizeForInObject(this.permissionsHeldRequirements)) {                  // 203
        if (Object.keys(this.permissionsHeldRequirements[grainId]).length > 0) {                                       // 204
          return false;                                                                                                // 205
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return true;                                                                                                     // 209
    }                                                                                                                  //
                                                                                                                       //
    return isEmpty;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype.addRequirements = function () {                                                             // 169
    function addRequirements(requirements) {                                                                           //
      var _this = this;                                                                                                //
                                                                                                                       //
      // Updates this RequirementSet to include the permissions required by `requirements`, which                      //
      // is a decoded Cap'n Proto List(MembraneRequirement).                                                           //
                                                                                                                       //
      if (!requirements) return;                                                                                       // 216
      requirements.forEach(function (requirement) {                                                                    // 217
        if (requirement.permissionsHeld) {                                                                             // 218
          var grainId = requirement.permissionsHeld.grainId;                                                           // 219
          var identityId = requirement.permissionsHeld.identityId;                                                     // 220
          var permissions = new PermissionSet(requirement.permissionsHeld.permissions);                                // 221
          _this._ensureEntryExists(grainId, identityId);                                                               // 222
          _this.permissionsHeldRequirements[grainId][identityId].add(permissions);                                     // 223
        } else if (requirement.userIsAdmin) {                                                                          //
          _this.userIsAdminRequirements[requirement.userIsAdmin] = true;                                               // 225
        } else if (requirement.tokenValid) {                                                                           //
          _this.tokenValidRequirements[requirement.tokenValid] = true;                                                 // 227
        } else {                                                                                                       //
          throw new Error("unsupported requirement: " + JSON.toString(requirement));                                   // 229
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return addRequirements;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype._ensureEntryExists = function () {                                                          // 169
    function _ensureEntryExists(grainId, identityId) {                                                                 //
      check(grainId, String);                                                                                          // 235
      check(identityId, String);                                                                                       // 236
                                                                                                                       //
      if (!this.permissionsHeldRequirements[grainId]) {                                                                // 238
        this.permissionsHeldRequirements[grainId] = {};                                                                // 239
      }                                                                                                                //
                                                                                                                       //
      if (!this.permissionsHeldRequirements[grainId][identityId]) {                                                    // 242
        this.permissionsHeldRequirements[grainId][identityId] = new PermissionSet([]);                                 // 243
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return _ensureEntryExists;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype.getGrainIds = function () {                                                                 // 169
    function getGrainIds() {                                                                                           //
      return Object.keys(this.permissionsHeldRequirements);                                                            // 248
    }                                                                                                                  //
                                                                                                                       //
    return getGrainIds;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype.getTokenIds = function () {                                                                 // 169
    function getTokenIds() {                                                                                           //
      return Object.keys(this.tokenValidRequirements);                                                                 // 252
    }                                                                                                                  //
                                                                                                                       //
    return getTokenIds;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype.forEach = function () {                                                                     // 169
    function forEach(func) {                                                                                           //
      for (var tokenId in meteorBabelHelpers.sanitizeForInObject(this.tokenValidRequirements)) {                       // 256
        func({ tokenValid: tokenId });                                                                                 // 257
      }                                                                                                                //
                                                                                                                       //
      for (var accountId in meteorBabelHelpers.sanitizeForInObject(this.userIsAdminRequirements)) {                    // 260
        func({ userIsAdmin: accountId });                                                                              // 261
      }                                                                                                                //
                                                                                                                       //
      for (var grainId in meteorBabelHelpers.sanitizeForInObject(this.permissionsHeldRequirements)) {                  // 264
        for (var identityId in meteorBabelHelpers.sanitizeForInObject(this.permissionsHeldRequirements[grainId])) {    // 265
          var permissions = this.permissionsHeldRequirements[grainId][identityId];                                     // 266
          func({                                                                                                       // 267
            permissionsHeld: {                                                                                         // 268
              grainId: grainId,                                                                                        // 269
              identityId: identityId,                                                                                  // 270
              permissionSet: permissions                                                                               // 271
            }                                                                                                          //
          });                                                                                                          //
        }                                                                                                              //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return forEach;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  return RequirementSet;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
// A permission ID is either the string "canAccess", corresponding to the implicit "can access                         //
// the grain at all" permission, or a non-negative integer, corresponding to a permission                              //
// defined by the app in its manifest.                                                                                 //
                                                                                                                       //
                                                                                                                       //
var PermissionId = Match.OneOf("canAccess", Match.Integer);                                                            // 282
                                                                                                                       //
function forEachPermission(permissions, func) {                                                                        // 284
  // Calls `func` on "canAccess" and each permission ID that corresponds to a `true`                                   //
  // value in `permissions`.                                                                                           //
  check(permissions, [Boolean]);                                                                                       // 287
  func("canAccess");                                                                                                   // 288
  for (var ii = 0; ii < permissions.length; ++ii) {                                                                    // 289
    if (permissions[ii]) {                                                                                             // 290
      func(ii);                                                                                                        // 291
    }                                                                                                                  //
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
// A vertex is a principal in the sharing graph. A "vertex ID" is either "i:" + an identity ID,                        //
// or "t:" + a token ID. In some limited contexts, "o:Owner" is also allowed, signifying the                           //
// *account* of the grain owner, from which all permissions flow.                                                      //
                                                                                                                       //
function vertexIdOfTokenOwner(token) {                                                                                 // 300
  // Returns which vertex recieves permissions from this token.                                                        //
                                                                                                                       //
  var result = "t:" + token._id; // the bearer of the token                                                            // 303
  if (token.owner && token.owner.user) {                                                                               // 300
    result = "i:" + token.owner.user.identityId; // the identity that owns the token                                   // 305
  }                                                                                                                    // 304
                                                                                                                       //
  return result;                                                                                                       // 308
}                                                                                                                      //
                                                                                                                       //
var Variable =                                                                                                         //
// Our permissions computation can be framed as a propositional HORNSAT problem; this `Variable`                       //
// class represents a variable in that sense. There is a variable for every (grain ID, vertex ID,                      //
// permission ID) triple. There is also a variable for every non-UiView ApiToken, to account for                       //
// `tokenValid` requirements. In any given computation, we only explicitly construct those                             //
// variables that we know might actually be relevant to the result.                                                    //
//                                                                                                                     //
// The value of a variable represents an answer to the question "does this vertex in the sharing                       //
// graph receive this permission at this grain?" We start out by setting all variables to `false`,                     //
// and we only set a variable to `true` when an edge in the sharing graph forces us to. If                             //
// this forward-chaining eventually forces us to set our end goal variables to `true`, then the                        //
// HORNSAT problem is unsatisfiable and we have proved what we wanted. Otherwise, the HORNSAT                          //
// problem is satisfiable, i.e. there is a consistent way to set values to variables in which                          //
// our goal nodes do *not* receive the permissions we wanted them to receive.                                          //
                                                                                                                       //
function () {                                                                                                          //
  function Variable() {                                                                                                // 326
    (0, _classCallCheck3["default"])(this, Variable);                                                                  //
                                                                                                                       //
    this.value = false;                                                                                                // 327
                                                                                                                       //
    this.directDependents = [];                                                                                        // 329
    // List of token IDs for outgoing edges that need to be looked at once this variable gets set                      //
    // to `true`.                                                                                                      //
                                                                                                                       //
    this.requirementDependents = [];                                                                                   // 326
    // List of token IDs for tokens that have requirements that get fulfilled once this variable                       //
    // gets set to `true`.                                                                                             //
  }                                                                                                                    // 326
                                                                                                                       //
  return Variable;                                                                                                     //
}();                                                                                                                   //
                                                                                                                       //
var ActiveToken = function () {                                                                                        //
  // An "active token" is one that we allow to propagate permissions because we've decided                             //
  // that it might be relevant to our current computation. This class tracks which permissions                         //
  // the token can carry, which of those permissions we've actually proved to arrive at the source                     //
  // end of the token, and how many of the token's requirements are still unmet.                                       //
                                                                                                                       //
  function ActiveToken(tokenId, requirements, numUnmetRequirements, permissions, grainId, recipientId) {               // 345
    (0, _classCallCheck3["default"])(this, ActiveToken);                                                               //
                                                                                                                       //
    check(tokenId, String);                                                                                            // 346
    check(numUnmetRequirements, Match.Integer);                                                                        // 347
    check(grainId, String);                                                                                            // 348
    check(recipientId, String);                                                                                        // 349
                                                                                                                       //
    check(permissions, [Boolean]);                                                                                     // 351
    // The permissions that this token is capable of carrying, in addition to the implicit                             //
    // "canAccess" permission.                                                                                         //
                                                                                                                       //
    this.tokenId = tokenId;                                                                                            // 345
    this.requirements = requirements;                                                                                  // 356
    this.grainId = grainId;                                                                                            // 357
    this.recipientId = recipientId;                                                                                    // 358
                                                                                                                       //
    this.numUnmetRequirements = numUnmetRequirements;                                                                  // 360
    // How many of this token's requirements we have not yet proven to be met.                                         //
                                                                                                                       //
    this.receivedPermissions = new Array();                                                                            // 345
    // A map from permission ID to boolean. If a permission ID is present in this map,                                 //
    // then this token's roleAssignment includes that permission. If the corresponding                                 //
    // value is `true`, then we've proven that this token receives this permission and                                 //
    // therefore propagates it if the requirements are met.                                                            //
                                                                                                                       //
    this.receivedPermissions.canAccess = false;                                                                        // 345
    for (var ii = 0; ii < permissions.length; ++ii) {                                                                  // 370
      if (permissions[ii]) {                                                                                           // 371
        this.receivedPermissions[ii] = false;                                                                          // 372
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  ActiveToken.prototype.requirementsAreMet = function () {                                                             // 339
    function requirementsAreMet() {                                                                                    //
      // Have we yet proved that all of this token's requirements are met?                                             //
      return this.numUnmetRequirements == 0;                                                                           // 379
    }                                                                                                                  //
                                                                                                                       //
    return requirementsAreMet;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  ActiveToken.prototype.decrementRequirements = function () {                                                          // 339
    function decrementRequirements(context) {                                                                          //
      var _this2 = this;                                                                                               //
                                                                                                                       //
      // Decrements the number of unmet requirements of this token.                                                    //
      check(context, Context);                                                                                         // 384
      this.numUnmetRequirements -= 1;                                                                                  // 385
      if (this.numUnmetRequirements < 0) {                                                                             // 386
        throw new Meteor.Error(500, "numUnmetRequirements is negative");                                               // 387
      }                                                                                                                //
                                                                                                                       //
      if (this.requirementsAreMet()) {                                                                                 // 390
        // This was the last missing requirement for this token, therefore we've triggered the                         //
        // outgoing edges from the token corresponding to each known incoming permission.                              //
        this.forEachReceivedPermission(function (permissionId) {                                                       // 393
          // We've triggered a new edge! Push it onto the queue.                                                       //
          context.setToTrueStack.push({ grainId: _this2.grainId,                                                       // 395
            vertexId: _this2.recipientId,                                                                              // 396
            permissionId: permissionId,                                                                                // 397
            responsibleTokenId: _this2.tokenId });                                                                     // 398
        });                                                                                                            //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return decrementRequirements;                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  ActiveToken.prototype.setReceivesPermission = function () {                                                          // 339
    function setReceivesPermission(permissionId, context) {                                                            //
      // Records that this token receives a permission.                                                                //
      check(permissionId, PermissionId);                                                                               // 405
      check(context, Context);                                                                                         // 406
      if (permissionId in this.receivedPermissions) {                                                                  // 407
        this.receivedPermissions[permissionId] = true;                                                                 // 408
      }                                                                                                                //
                                                                                                                       //
      if (this.numUnmetRequirements == 0) {                                                                            // 411
        context.setToTrueStack.push({ grainId: this.grainId,                                                           // 412
          vertexId: this.recipientId,                                                                                  // 413
          permissionId: permissionId,                                                                                  // 414
          responsibleTokenId: this.tokenId });                                                                         // 415
      } else {                                                                                                         //
        // Since we know permissions flow to this token, and the token is active (meaning it                           //
        // may be relevant to the overall computation), we now know that it's worth checking                           //
        // the token's requirements. Add them to `unmetRequirements`. Note that these requirement                      //
        // could actually be ones that we've checked already, but we'll figure that out once                           //
        // processUnmetRequirements() runs and discovers it isn't activating any new tokens.                           //
        //                                                                                                             //
        // TODO(perf): This is an overestimate. It might be worthwhile to keep track of which                          //
        //   requirements are already met, so that we don't need to add them here.                                     //
                                                                                                                       //
        context.unmetRequirements.addRequirements(this.requirements);                                                  // 426
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return setReceivesPermission;                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  ActiveToken.prototype.forEachReceivedPermission = function () {                                                      // 339
    function forEachReceivedPermission(func) {                                                                         //
      // Calls `func` on each permission ID that we've proven this token receives.                                     //
                                                                                                                       //
      if (this.receivedPermissions.canAccess) {                                                                        // 433
        func("canAccess");                                                                                             // 434
      }                                                                                                                //
                                                                                                                       //
      // Note: Array.forEach() does hit the "canAccess" permission ID.                                                 //
      this.receivedPermissions.forEach(function (received, permissionId) {                                             // 430
        if (received) {                                                                                                // 439
          func(permissionId);                                                                                          // 440
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return forEachReceivedPermission;                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  return ActiveToken;                                                                                                  //
}();                                                                                                                   //
                                                                                                                       //
var Context = function () {                                                                                            //
  // An ongoing permissions computation, including cached database state.                                              //
                                                                                                                       //
  function Context() {                                                                                                 // 449
    (0, _classCallCheck3["default"])(this, Context);                                                                   //
                                                                                                                       //
    this.grains = {}; // Map from grain ID to entry in Grains table.                                                   // 450
    this.userIdentityIds = {}; // Map from account ID to list of linked identity IDs.                                  // 449
    this.adminUsers = {}; // Set of account IDs for admins.                                                            // 449
    this.tokensById = {}; // Map from token ID to token.                                                               // 449
    this.tokensByRecipient = {}; // Map from grain ID and identity ID to token array.                                  // 449
                                                                                                                       //
    this.variables = {};                                                                                               // 449
    // GrainId -> VertexId -> PermissionId -> Variable                                                                 //
    //                                                                                                                 //
    // We have a special fake grain ID "tokenValid", where we store the variables that track                           //
    // `tokenValid` requirements. Only the "canAccess" permission makes sense for that fake grain.                     //
                                                                                                                       //
    this.userIsAdminVariables = {};                                                                                    // 449
    // Account ID -> Variable                                                                                          //
                                                                                                                       //
    this.activeTokens = {}; // TokenId -> ActiveToken                                                                  // 449
                                                                                                                       //
    this.setToTrueStack = [];                                                                                          // 449
    // Variables enqueued to be set to true.                                                                           //
    // Array of { grainId: String, vertexId: String, permissionId: PermissionId,                                       //
    //            responsibleTokenId: Optional(String) }                                                               //
                                                                                                                       //
    this.unmetRequirements = new RequirementSet();                                                                     // 449
    // As we run our forward-chaining algorithm, when we encounter a token with unmet requirements                     //
    // we add those requirements to this set. Then, if we find that our current knowledge base                         //
    // is not large enough to prove our goal, we can expand our search by following these                              //
    // requirements backwards and activating tokens that might help prove that they are met.                           //
    // `unmetRequirements` is allowed to be an overestimate -- in fact, when adding requirements                       //
    // to `unmetRequirements` we generally do not check if they had already been proven. The next                      //
    // run of processUnmetRequirements(), however, will find that all of the tokens activated by                       //
    // the requirements were already active.                                                                           //
  }                                                                                                                    // 449
                                                                                                                       //
  Context.prototype.reset = function () {                                                                              // 446
    function reset() {                                                                                                 //
      // Resets all state except this.grains, this.userIdentityIds, and this.adminUsers.                               //
      this.tokensById = {};                                                                                            // 485
      this.tokensByRecipient = {};                                                                                     // 486
      this.unmetRequirements = new RequirementSet();                                                                   // 487
      this.setToTrueStack = [];                                                                                        // 488
      this.variables = {};                                                                                             // 489
      this.activeTokens = {};                                                                                          // 490
    }                                                                                                                  //
                                                                                                                       //
    return reset;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.addToken = function () {                                                                           // 446
    function addToken(token) {                                                                                         //
      // Adds a token to `this.tokensById`. If the token is a UiView, also adds it to                                  //
      // `this.tokensByRecipient`. Does not activate the token.                                                        //
                                                                                                                       //
      var isUiView = token.grainId && !token.objectId;                                                                 // 497
                                                                                                                       //
      if (this.tokensById[token._id]) return;                                                                          // 499
                                                                                                                       //
      this.tokensById[token._id] = token;                                                                              // 501
      if (isUiView && token.owner && token.owner.user) {                                                               // 502
        if (!this.tokensByRecipient[token.grainId]) {                                                                  // 503
          this.tokensByRecipient[token.grainId] = {};                                                                  // 504
        }                                                                                                              //
                                                                                                                       //
        if (!this.tokensByRecipient[token.grainId][token.owner.user.identityId]) {                                     // 507
          this.tokensByRecipient[token.grainId][token.owner.user.identityId] = [];                                     // 508
        }                                                                                                              //
                                                                                                                       //
        this.tokensByRecipient[token.grainId][token.owner.user.identityId].push(token);                                // 511
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return addToken;                                                                                                   //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.addGrains = function () {                                                                          // 446
    function addGrains(db, grainIds) {                                                                                 //
      var _this3 = this;                                                                                               //
                                                                                                                       //
      // Retrieves grains from the database.                                                                           //
                                                                                                                       //
      check(db, SandstormDb);                                                                                          // 518
      check(grainIds, [String]);                                                                                       // 519
      if (grainIds.length == 0) return; // Nothing to do.                                                              // 520
                                                                                                                       //
      db.collections.grains.find({ _id: { $in: grainIds }, trashed: { $exists: false } }).forEach(function (grain) {   // 515
        _this3.grains[grain._id] = grain;                                                                              // 523
        if (!_this3.userIdentityIds[grain.userId]) {                                                                   // 524
          _this3.userIdentityIds[grain.userId] = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      var query = { grainId: { $in: grainIds },                                                                        // 530
        revoked: { $ne: true },                                                                                        // 531
        trashed: { $exists: false },                                                                                   // 532
        objectId: { $exists: false } };                                                                                // 533
      db.collections.apiTokens.find(query).forEach(function (token) {                                                  // 534
        return _this3.addToken(token);                                                                                 //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return addGrains;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.addTokensFromCursor = function () {                                                                // 446
    function addTokensFromCursor(cursor) {                                                                             //
      var _this4 = this;                                                                                               //
                                                                                                                       //
      cursor.forEach(function (token) {                                                                                // 538
        return _this4.addToken(token);                                                                                 //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return addTokensFromCursor;                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.activateOwnerEdges = function () {                                                                 // 446
    function activateOwnerEdges(grainId, edges) {                                                                      //
      var _this5 = this;                                                                                               //
                                                                                                                       //
      check(edges, [{ identityId: String, role: SandstormDb.prototype.roleAssignmentPattern }]);                       // 542
                                                                                                                       //
      edges.forEach(function (edge) {                                                                                  // 544
        var viewInfo = _this5.grains[grainId].cachedViewInfo || {};                                                    // 545
        var permissions = PermissionSet.fromRoleAssignment(edge.role, viewInfo);                                       // 546
        var vertexId = "i:" + edge.identityId;                                                                         // 547
        forEachPermission(permissions.array, function (permissionId) {                                                 // 548
          _this5.setToTrueStack.push({                                                                                 // 549
            grainId: grainId,                                                                                          // 550
            vertexId: vertexId,                                                                                        // 551
            permissionId: permissionId                                                                                 // 552
          });                                                                                                          //
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return activateOwnerEdges;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.registerInterestInRequirements = function () {                                                     // 446
    function registerInterestInRequirements(tokenId, requirements) {                                                   //
      var _this6 = this;                                                                                               //
                                                                                                                       //
      // Add all requirements.                                                                                         //
      var numUnmetRequirements = 0;                                                                                    // 560
      if (requirements) {                                                                                              // 561
        requirements.forEach(function (requirement) {                                                                  // 562
          if (requirement.permissionsHeld) {                                                                           // 563
            (function () {                                                                                             //
              var reqGrainId = requirement.permissionsHeld.grainId;                                                    // 564
              var reqVertexId = "i:" + requirement.permissionsHeld.identityId;                                         // 565
              var reqPermissions = requirement.permissionsHeld.permissions || [];                                      // 566
                                                                                                                       //
              forEachPermission(reqPermissions, function (permissionId) {                                              // 568
                var variable = _this6.getVariable(reqGrainId, reqVertexId, permissionId);                              // 569
                if (!variable.value) {                                                                                 // 570
                  // This requirement hasn't been proven yet. We add it to the variable's list of                      //
                  // dependents so that we get notified when that variable is proven, and we increment                 //
                  // numUnmetRequirements to indicate how many notifications we need to get before we                  //
                  // know all requirements are satisfied.                                                              //
                  numUnmetRequirements += 1;                                                                           // 575
                  variable.requirementDependents.push(tokenId);                                                        // 576
                }                                                                                                      //
              });                                                                                                      //
            })();                                                                                                      //
          } else if (requirement.userIsAdmin) {                                                                        //
            var accountId = requirement.userIsAdmin;                                                                   // 580
            var variable = _this6.getUserIsAdminVariable(accountId);                                                   // 581
            if (!variable.value) {                                                                                     // 582
              numUnmetRequirements += 1;                                                                               // 583
              variable.requirementDependents.push(tokenId);                                                            // 584
            }                                                                                                          //
          } else if (requirement.tokenValid) {                                                                         //
            var reqTokenId = requirement.tokenValid;                                                                   // 587
            var _variable = _this6.getVariable("tokenValid", "t:" + reqTokenId, "canAccess");                          // 588
            if (!_variable.value) {                                                                                    // 589
              numUnmetRequirements += 1;                                                                               // 590
              _variable.requirementDependents.push(tokenId);                                                           // 591
            }                                                                                                          //
          } else {                                                                                                     //
            throw new Error("unknown kind of requirement: " + JSON.stringify(requirement));                            // 594
          }                                                                                                            //
        });                                                                                                            //
      }                                                                                                                //
                                                                                                                       //
      return numUnmetRequirements;                                                                                     // 599
    }                                                                                                                  //
                                                                                                                       //
    return registerInterestInRequirements;                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.activateToken = function () {                                                                      // 446
    function activateToken(tokenId) {                                                                                  //
      var _this7 = this;                                                                                               //
                                                                                                                       //
      // Includes a new token (which must already be in `this.tokensById`) in our computation. The                     //
      // tricky part here is dealing with our already-accumulated knowledge; we need to compute how                    //
      // many of the token's requirements are currently unmet and whether we need to push anything new                 //
      // onto `setToTrueStack`.                                                                                        //
                                                                                                                       //
      check(tokenId, String);                                                                                          // 608
      if (tokenId in this.activeTokens) {                                                                              // 609
        return false;                                                                                                  // 610
      }                                                                                                                //
                                                                                                                       //
      var token = this.tokensById[tokenId];                                                                            // 613
      var grainId = token.grainId;                                                                                     // 614
      var viewInfo = this.grains[grainId].cachedViewInfo || {};                                                        // 615
      var tokenPermissions = PermissionSet.fromRoleAssignment(token.roleAssignment, viewInfo);                         // 616
                                                                                                                       //
      var sharerId = token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId;                           // 618
      var recipientId = vertexIdOfTokenOwner(token);                                                                   // 619
                                                                                                                       //
      var numUnmetRequirements = this.registerInterestInRequirements(tokenId, token.requirements);                     // 621
      var activeToken = new ActiveToken(tokenId, token.requirements, numUnmetRequirements, tokenPermissions.array, grainId, recipientId);
                                                                                                                       //
      // Add all edges represented by this token (one for each permission).                                            //
      forEachPermission(tokenPermissions.array, function (permissionId) {                                              // 602
        var recipientVariable = _this7.getVariable(grainId, recipientId, permissionId);                                // 627
        if (!recipientVariable.value) {                                                                                // 628
          var sharerVariable = _this7.getVariable(grainId, sharerId, permissionId);                                    // 629
          if (!sharerVariable.value) {                                                                                 // 630
            // Not proven yet that the source has this permission, so add to its direct dependents so                  //
            // that we get notified if that changes.                                                                   //
            sharerVariable.directDependents.push(tokenId);                                                             // 633
          } else {                                                                                                     //
            // The source has already been proven.                                                                     //
            activeToken.setReceivesPermission(permissionId, _this7);                                                   // 636
          }                                                                                                            //
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      this.activeTokens[tokenId] = activeToken;                                                                        // 641
                                                                                                                       //
      return true;                                                                                                     // 643
    }                                                                                                                  //
                                                                                                                       //
    return activateToken;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.activateTokenValidToken = function () {                                                            // 446
    function activateTokenValidToken(tokenId) {                                                                        //
      // Like `activateToken()`, but for a token that appears in a `tokenValid` requirement.                           //
      // Such tokens require some special handling to fit into our computation.                                        //
                                                                                                                       //
      check(tokenId, String);                                                                                          // 650
      if (tokenId in this.activeTokens) {                                                                              // 651
        return false;                                                                                                  // 652
      }                                                                                                                //
                                                                                                                       //
      var token = this.tokensById[tokenId];                                                                            // 655
      if (!token) {                                                                                                    // 656
        return false;                                                                                                  // 657
      }                                                                                                                //
                                                                                                                       //
      var numUnmetRequirements = this.registerInterestInRequirements(tokenId, token.requirements);                     // 660
      var activeToken = new ActiveToken(tokenId, token.requirements, numUnmetRequirements, [], "tokenValid", "t:" + tokenId);
                                                                                                                       //
      var recipientId = "t:" + tokenId;                                                                                // 664
      var sharerVariable = token.parentToken && this.getVariable("tokenValid", "t:" + token.parentToken, "canAccess");
                                                                                                                       //
      var recipientVariable = this.getVariable("tokenValid", recipientId, "canAccess");                                // 668
      if (!recipientVariable.value) {                                                                                  // 669
        if (!token.parentToken || sharerVariable && sharerVariable.value) {                                            // 670
          // The source has already been proven.                                                                       //
          activeToken.setReceivesPermission("canAccess", this);                                                        // 672
        } else {                                                                                                       //
          // Not proven yet that the source has this permission, so add to its direct dependents so                    //
          // that we get notified if that changes.                                                                     //
          sharerVariable.directDependents.push(tokenId);                                                               // 676
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      this.activeTokens[tokenId] = activeToken;                                                                        // 680
                                                                                                                       //
      return true;                                                                                                     // 682
    }                                                                                                                  //
                                                                                                                       //
    return activateTokenValidToken;                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.getVariable = function () {                                                                        // 446
    function getVariable(grainId, vertexId, permissionId) {                                                            //
      check(grainId, String);                                                                                          // 686
      check(vertexId, String);                                                                                         // 687
      check(permissionId, PermissionId);                                                                               // 688
                                                                                                                       //
      if (!this.variables[grainId]) {                                                                                  // 690
        this.variables[grainId] = {};                                                                                  // 691
      }                                                                                                                //
                                                                                                                       //
      if (!this.variables[grainId][vertexId]) {                                                                        // 694
        this.variables[grainId][vertexId] = new Array();                                                               // 695
      }                                                                                                                //
                                                                                                                       //
      if (!this.variables[grainId][vertexId][permissionId]) {                                                          // 698
        this.variables[grainId][vertexId][permissionId] = new Variable();                                              // 699
      }                                                                                                                //
                                                                                                                       //
      return this.variables[grainId][vertexId][permissionId];                                                          // 702
    }                                                                                                                  //
                                                                                                                       //
    return getVariable;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.getUserIsAdminVariable = function () {                                                             // 446
    function getUserIsAdminVariable(accountId) {                                                                       //
      check(accountId, String);                                                                                        // 706
                                                                                                                       //
      if (!this.userIsAdminVariables[accountId]) {                                                                     // 708
        this.userIsAdminVariables[accountId] = new Variable();                                                         // 709
      }                                                                                                                //
                                                                                                                       //
      return this.userIsAdminVariables[accountId];                                                                     // 712
    }                                                                                                                  //
                                                                                                                       //
    return getUserIsAdminVariable;                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.getPermissions = function () {                                                                     // 446
    function getPermissions(grainId, vertexId) {                                                                       //
      // Looks up the permissions that have already been proven for the `vertexId` on `grainId`.                       //
                                                                                                                       //
      check(grainId, String);                                                                                          // 718
      check(vertexId, String);                                                                                         // 719
                                                                                                                       //
      if (!this.getVariable(grainId, vertexId, "canAccess").value) {                                                   // 721
        return null;                                                                                                   // 722
      } else {                                                                                                         //
        var length = this.variables[grainId][vertexId].length;                                                         // 724
        var permissions = new Array(length);                                                                           // 725
        for (var idx = 0; idx < length; ++idx) {                                                                       // 726
          if (this.variables[grainId][vertexId][idx]) {                                                                // 727
            permissions[idx] = !!this.variables[grainId][vertexId][idx].value;                                         // 728
          } else {                                                                                                     //
            permissions[idx] = false;                                                                                  // 730
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        return new PermissionSet(permissions);                                                                         // 734
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return getPermissions;                                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.runForwardChaining = function () {                                                                 // 446
    function runForwardChaining(grainId, vertexId, permissionSet) {                                                    //
      var _this8 = this;                                                                                               //
                                                                                                                       //
      // Runs forward-chaining, consuming elements from `this.setToTrueStack` and propagating                          //
      // their permissions, until we've proven that `(grainId, vertexId)` has the permissions in                       //
      // `permissionSet`, or until we've exhausted `this.setToTrueStack`.                                              //
      //                                                                                                               //
      // TODO(perf): Exit early if we've already proven that permissionSet is fulfilled.                               //
                                                                                                                       //
      check(grainId, String);                                                                                          // 745
      check(vertexId, String);                                                                                         // 746
      check(permissionSet, PermissionSet);                                                                             // 747
                                                                                                                       //
      if (permissionSet.array.length > 0) {                                                                            // 749
        // Make sure that the result of this call, retrieved through `this.getPermissions()`,                          //
        // will have a full array of permissions, even if they won't all be set to `true`.                             //
        this.getVariable(grainId, vertexId, permissionSet.array.length - 1);                                           // 752
      }                                                                                                                //
                                                                                                                       //
      var _loop = function () {                                                                                        //
        function _loop() {                                                                                             //
          var current = _this8.setToTrueStack.pop();                                                                   // 756
          var variable = _this8.getVariable(current.grainId, current.vertexId, current.permissionId);                  // 757
          if (variable.value) {                                                                                        // 758
            return "continue";                                                                                         // 759
          }                                                                                                            //
                                                                                                                       //
          // For the first time, this vertex is now known to be satisfied.                                             //
          variable.value = true;                                                                                       // 763
                                                                                                                       //
          // For each edge (token) whose source is this vertex, mark that the input permission is                      //
          // fulfilled.                                                                                                //
          variable.responsibleTokenId = current.responsibleTokenId;                                                    // 767
          variable.directDependents.forEach(function (tokenId) {                                                       // 768
            // We know this permission must be met now. We also know that the permission was not met                   //
            // for this token previously becaues a token has exactly one source vertex for each                        //
            // permission, and we're processing that vertex now.                                                       //
                                                                                                                       //
            _this8.activeTokens[tokenId].setReceivesPermission(current.permissionId, _this8);                          // 773
          });                                                                                                          //
                                                                                                                       //
          // For each token that has a requirement on this vertex, mark that one of its requirements                   //
          // has ben fulfilled.                                                                                        //
          variable.requirementDependents.forEach(function (tokenId) {                                                  // 778
            _this8.activeTokens[tokenId].decrementRequirements(_this8);                                                // 779
          });                                                                                                          //
        }                                                                                                              //
                                                                                                                       //
        return _loop;                                                                                                  //
      }();                                                                                                             //
                                                                                                                       //
      while (this.setToTrueStack.length > 0) {                                                                         // 755
        var _ret2 = _loop();                                                                                           //
                                                                                                                       //
        if (_ret2 === "continue") continue;                                                                            //
      }                                                                                                                //
                                                                                                                       //
      return this.getPermissions(grainId, vertexId);                                                                   // 783
    }                                                                                                                  //
                                                                                                                       //
    return runForwardChaining;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.activateRelevantTokens = function () {                                                             // 446
    function activateRelevantTokens(grainId, vertexId) {                                                               //
      var _this9 = this;                                                                                               //
                                                                                                                       //
      // Returns true if more computation might yield more progress.                                                   //
                                                                                                                       //
      check(grainId, String);                                                                                          // 789
      check(vertexId, String);                                                                                         // 790
                                                                                                                       //
      var result = false;                                                                                              // 792
      var relevant = computeRelevantTokens(this, grainId, vertexId);                                                   // 793
      this.activateOwnerEdges(grainId, relevant.ownerEdges);                                                           // 794
      relevant.tokenIds.forEach(function (tokenId) {                                                                   // 795
        if (_this9.activateToken(tokenId)) {                                                                           // 796
          result = true;                                                                                               // 797
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      return result;                                                                                                   // 801
    }                                                                                                                  //
                                                                                                                       //
    return activateRelevantTokens;                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.processUnmetRequirements = function () {                                                           // 446
    function processUnmetRequirements(db) {                                                                            //
      var _this10 = this;                                                                                              //
                                                                                                                       //
      // Activate all tokens relevant to the requirements in `unmetRequirements`. May do a database                    //
      // query to look up new tokens.                                                                                  //
      //                                                                                                               //
      // Returns true if more computation might yield more progress, i.e., at least one token was                      //
      // newly-activated.                                                                                              //
                                                                                                                       //
      var grainIds = this.unmetRequirements.getGrainIds().filter(function (grainId) {                                  // 811
        return !(grainId in _this10.grains);                                                                           //
      });                                                                                                              //
                                                                                                                       //
      if (db) {                                                                                                        // 814
        this.addGrains(db, grainIds);                                                                                  // 815
      }                                                                                                                //
                                                                                                                       //
      var result = false;                                                                                              // 818
                                                                                                                       //
      // As we process our requirements, we might find new unmet requirments.                                          //
      // We defer processing those until the next time around.                                                         //
      var oldUnmetRequirements = this.unmetRequirements;                                                               // 804
      this.unmetRequirements = new RequirementSet();                                                                   // 823
                                                                                                                       //
      oldUnmetRequirements.forEach(function (req) {                                                                    // 825
        if (req.permissionsHeld) {                                                                                     // 826
          var next = req.permissionsHeld;                                                                              // 827
          // Activate all tokens relevant to this requirement.                                                         //
          // TODO(perf): We're actually overestimating, because we're activating tokens relevant to                    //
          //   *all* permissions rather than just the permissions specified by the requirement. E.g.                   //
          //   if the requirement is that Bob has write access, then tokens which only transmit read                   //
          //   access are not relevant, but we'll end up activating them anyway.                                       //
          if (_this10.activateRelevantTokens(next.grainId, "i:" + next.identityId)) {                                  // 826
            result = true;                                                                                             // 834
          }                                                                                                            //
        } else if (req.tokenValid) {                                                                                   //
          // Active the token and all of its transitive parents.                                                       //
          var currentTokenId = req.tokenValid;                                                                         // 838
          while (true) {                                                                                               // 839
            var currentToken = _this10.tokensById[currentTokenId];                                                     // 840
            if (!currentToken && db) {                                                                                 // 841
              currentToken = db.collections.apiTokens.findOne({                                                        // 842
                _id: currentTokenId,                                                                                   // 843
                revoked: { $ne: true }                                                                                 // 844
              });                                                                                                      //
              _this10.tokensById[currentTokenId] = currentToken;                                                       // 846
            }                                                                                                          //
                                                                                                                       //
            if (!currentToken) {                                                                                       // 849
              break;                                                                                                   // 850
            }                                                                                                          //
                                                                                                                       //
            if (_this10.activateTokenValidToken(currentTokenId)) {                                                     // 853
              result = true;                                                                                           // 854
            }                                                                                                          //
                                                                                                                       //
            if (currentToken.parentToken) {                                                                            // 857
              currentTokenId = currentToken.parentToken;                                                               // 858
            } else {                                                                                                   //
              break;                                                                                                   // 860
            }                                                                                                          //
          }                                                                                                            //
        } else if (req.userIsAdmin) {                                                                                  //
          var accountId = req.userIsAdmin;                                                                             // 864
          if (!(accountId in _this10.adminUsers) && db) {                                                              // 865
            Meteor.users.find({ isAdmin: true }).forEach(function (user) {                                             // 866
              _this10.adminUsers[user._id] = true;                                                                     // 867
            });                                                                                                        //
          }                                                                                                            //
                                                                                                                       //
          if (_this10.adminUsers[accountId]) {                                                                         // 871
            var variable = _this10.getUserIsAdminVariable(accountId);                                                  // 872
            variable.value = true;                                                                                     // 873
                                                                                                                       //
            // Might have some requirement dependents. Cannot have any direct depependents.                            //
            variable.requirementDependents.forEach(function (tokenId) {                                                // 871
              result = true;                                                                                           // 877
              _this10.activeTokens[tokenId].decrementRequirements(_this10);                                            // 878
            });                                                                                                        //
          }                                                                                                            //
        } else {                                                                                                       //
          throw new Error("unknown kind of requirement: " + JSON.stringify(req));                                      // 882
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      return result;                                                                                                   // 886
    }                                                                                                                  //
                                                                                                                       //
    return processUnmetRequirements;                                                                                   //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.tryToProve = function () {                                                                         // 446
    function tryToProve(grainId, vertexId, permissionSet, db) {                                                        //
      // Tries to prove that `vertexId` has the given permissions on the given grain. Returns a                        //
      // `PermissionSet` representing the permissions proven, or null if it has not been proved                        //
      // yet that the vertex even has access to the grain.                                                             //
                                                                                                                       //
      check(grainId, String);                                                                                          // 894
      check(vertexId, String);                                                                                         // 895
      check(permissionSet, PermissionSet);                                                                             // 896
      check(db, Match.OneOf(undefined, SandstormDb));                                                                  // 897
      // If `db` is not provided, then this function will make no database queries.                                    //
                                                                                                                       //
      if (db) {                                                                                                        // 889
        this.addGrains(db, [grainId]);                                                                                 // 901
      }                                                                                                                //
                                                                                                                       //
      this.activateRelevantTokens(grainId, vertexId);                                                                  // 904
      while (true) {                                                                                                   // 905
        var result = this.runForwardChaining(grainId, vertexId, permissionSet);                                        // 906
        if (result && permissionSet.isSubsetOf(result)) {                                                              // 907
          return result;                                                                                               // 908
        }                                                                                                              //
                                                                                                                       //
        if (!this.processUnmetRequirements(db)) {                                                                      // 911
          return result;                                                                                               // 912
        }                                                                                                              //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return tryToProve;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.getResponsibleTokens = function () {                                                               // 446
    function getResponsibleTokens(grainId, vertexId) {                                                                 //
      // For the permissions that we've already proven must be held by `vertexId`, transitively finds                  //
      // the tokens that we have used in that proof, including tokens responsible for fulfilling                       //
      // membrane requirements.                                                                                        //
      //                                                                                                               //
      // Whenever we prove a fact, we keep track of the immediately responsible token for that fact,                   //
      // This function works by walking backwards in the sharing graph, following this trail of                        //
      // "responsible tokens".                                                                                         //
      //                                                                                                               //
      // Returns an object with two fields:                                                                            //
      //    tokenIds: list of IDs of the responsible tokens.                                                           //
      //    grainIds: list of IDs of all relevant grains.                                                              //
                                                                                                                       //
      check(grainId, String);                                                                                          // 930
      check(vertexId, String);                                                                                         // 931
                                                                                                                       //
      var stack = []; // [{ grainId: String, vertexId: String, permissionId: PermissionId }]                           // 933
      var visited = new Array(); // grainId -> vertexId -> permissionId -> bool;                                       // 917
                                                                                                                       //
      function pushVertex(grainId, vertexId, permissionId) {                                                           // 917
        if (!visited[grainId]) {                                                                                       // 937
          visited[grainId] = {};                                                                                       // 938
        }                                                                                                              //
                                                                                                                       //
        if (!visited[grainId][vertexId]) {                                                                             // 941
          visited[grainId][vertexId] = {};                                                                             // 942
        }                                                                                                              //
                                                                                                                       //
        var vertex = visited[grainId][vertexId];                                                                       // 945
        if (!vertex[permissionId]) {                                                                                   // 946
          vertex[permissionId] = true;                                                                                 // 947
          stack.push({ grainId: grainId, vertexId: vertexId, permissionId: permissionId });                            // 948
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      var neededTokens = {}; // TokenId -> bool                                                                        // 952
                                                                                                                       //
      forEachPermission(this.getPermissions(grainId, vertexId).array, function (permissionId) {                        // 917
        pushVertex(grainId, vertexId, permissionId);                                                                   // 955
      });                                                                                                              //
                                                                                                                       //
      while (stack.length > 0) {                                                                                       // 958
        var _current = stack.pop();                                                                                    // 959
        var variable = this.getVariable(_current.grainId, _current.vertexId, _current.permissionId);                   // 960
        var tokenId = variable.responsibleTokenId;                                                                     // 961
        if (tokenId) {                                                                                                 // 962
          var token = this.tokensById[tokenId];                                                                        // 963
                                                                                                                       //
          if (token.grainId && !token.objectId) {                                                                      // 965
            var sharerId = token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId;                     // 966
            pushVertex(token.grainId, sharerId, _current.permissionId);                                                // 967
          } else if (token.parentToken) {                                                                              //
            pushVertex("tokenValid", "t:" + token.parentToken, "canAccess");                                           // 969
          }                                                                                                            //
                                                                                                                       //
          if (!neededTokens[tokenId]) {                                                                                // 972
            neededTokens[tokenId] = true;                                                                              // 973
            if (token.requirements) {                                                                                  // 974
              token.requirements.forEach(function (requirement) {                                                      // 975
                if (requirement.permissionsHeld) {                                                                     // 976
                  (function () {                                                                                       //
                    var reqVertexId = "i:" + requirement.permissionsHeld.identityId;                                   // 977
                    forEachPermission(requirement.permissionsHeld.permissions, function (permissionId) {               // 978
                      pushVertex(requirement.permissionsHeld.grainId, reqVertexId, permissionId);                      // 979
                    });                                                                                                //
                  })();                                                                                                //
                } else if (requirement.tokenValid) {                                                                   //
                  pushVertex("tokenValid", "t:" + requirement.tokenValid, "canAccess");                                // 982
                }                                                                                                      //
              });                                                                                                      //
            }                                                                                                          //
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return { tokenIds: Object.keys(neededTokens), grainIds: Object.keys(visited) };                                  // 990
    }                                                                                                                  //
                                                                                                                       //
    return getResponsibleTokens;                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return Context;                                                                                                      //
}();                                                                                                                   //
                                                                                                                       //
function computeRelevantTokens(context, grainId, vertexId) {                                                           // 994
  // Finds all tokens in `context` that could possibly carry permissions of the grain `grainId` to                     //
  // the vertex `vertexId` -- that is, all tokens that are contained in a path starting at the                         //
  // grain owner and ending at `vertexId`. Ignores any requirements that those tokens might be                         //
  // conditional upon.                                                                                                 //
  //                                                                                                                   //
  // Returns an object with two fields:                                                                                //
  //    tokenIds: list of relevant token IDs.                                                                          //
  //    ownerEdges: objects of the form { identityId: String, role: RoleAssignment }, representing                     //
  //                initial pseudo-edges in the graph. `identityId` is typically an identity of                        //
  //                the grain's owning user, but for the case of a legacy public grain it could                        //
  //                be any identity.                                                                                   //
  //                                                                                                                   //
  // Works by traversing the sharing graph twice: first backwards starting from `vertexId`, then                       //
  // forwards starting from the grain owner using only those tokens touched in the first step.                         //
  //                                                                                                                   //
  // `context` contains all the information from the database which is available for now. This call                    //
  // will not make any new database lookups; edges not listed in `context` will not be considered                      //
  // (as if they'd been revoked).                                                                                      //
                                                                                                                       //
  check(context, Context);                                                                                             // 1014
  check(grainId, String);                                                                                              // 1015
  check(vertexId, String);                                                                                             // 1016
                                                                                                                       //
  var grain = context.grains[grainId];                                                                                 // 1018
  if (!grain) return { tokenIds: [], ownerEdges: [] };                                                                 // 1019
  var viewInfo = grain.cachedViewInfo || {};                                                                           // 1020
  var ownerIdentityIds = context.userIdentityIds[grain.userId];                                                        // 1021
                                                                                                                       //
  var vertexStack = []; // Vertex IDs that we need to explore.                                                         // 1023
  var visitedVertexIds = {}; // Set of vertex IDs that we have already enqueued to get explored.                       // 994
                                                                                                                       //
  visitedVertexIds[vertexId] = true;                                                                                   // 994
  vertexStack.push(vertexId);                                                                                          // 1027
                                                                                                                       //
  var visitedTokensBySharerId = {};                                                                                    // 1029
  var ownerEdges = [];                                                                                                 // 1030
                                                                                                                       //
  // Repeatedly pop a vertex from the stack, find all its incoming edges (i.e. all other vertexes                      //
  // that share permissions to this vertex), and push those vertexes onto the stack.                                   //
                                                                                                                       // 994
  var _loop2 = function _loop2() {                                                                                     //
    var vertexId = vertexStack.pop();                                                                                  // 1035
                                                                                                                       //
    var incomingEdges = [];                                                                                            // 1037
    // List of edges in the sharing graph ending at this vertex. Each is an object with the fields:                    //
    //     sharerId: The vertex ID of the edge's source.                                                               //
    //     token: the token object backing this edge, if there is one.                                                 //
                                                                                                                       //
    function tokenToEdge(token) {                                                                                      // 1042
      // Convert an ApiToken into an edge.                                                                             //
      return {                                                                                                         // 1044
        token: token,                                                                                                  // 1045
        sharerId: token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId                               // 1046
      };                                                                                                               //
    }                                                                                                                  //
                                                                                                                       //
    if (vertexId.slice(0, 2) === "o:") {                                                                               // 1050
      // Owner. We don't need to do anything.                                                                          //
      incomingEdges = [];                                                                                              // 1052
    } else if (vertexId.slice(0, 2) === "t:") {                                                                        //
      // A webkey token. Extract it from the context (or ignore if it isn't present).                                  //
      var _token = context.tokensById[vertexId.slice(2)];                                                              // 1055
      if (_token) {                                                                                                    // 1056
        incomingEdges = [tokenToEdge(_token)];                                                                         // 1057
      }                                                                                                                //
    } else if (vertexId.slice(0, 2) === "i:") {                                                                        //
      // An identity.                                                                                                  //
      var identityId = vertexId.slice(2);                                                                              // 1061
      if (ownerIdentityIds.indexOf(identityId) >= 0) {                                                                 // 1062
        // This is one of the owner's identities.                                                                      //
        incomingEdges = [{ sharerId: "o:Owner" }];                                                                     // 1064
        ownerEdges.push({ identityId: identityId, role: { allAccess: null } });                                        // 1065
      } else if (!grain["private"]) {                                                                                  //
        // This is a legacy "public" grain, meaning that any user who knows the grain ID receives                      //
        // the grain's default role. If the user doesn't know the grain ID then they are unable                        //
        // to express a request to open the grain in the first place and we'll never get to the                        //
        // point of this permissions computation, so for this purpose we can assume all users                          //
        // have the default role. (Similarly, a user who doesn't know the grain ID couldn't                            //
        // possibly be the subject of any MembraneRequirements against the grain because they                          //
        // have never interacted with the grain and so couldn't have caused such                                       //
        // MembraneRequiments to come about. Note that this is kind of shaky non-local reasoning,                      //
        // but literally no such legacy grain has been created since early 2015 and none will ever                     //
        // be created again, so it's not a huge deal.)                                                                 //
        incomingEdges = [{ sharerId: "o:Owner" }];                                                                     // 1077
        ownerEdges.push({ identityId: identityId, role: { none: null } });                                             // 1078
      } else {                                                                                                         //
        // Not a special case. Gather all tokens where this user is the recipient.                                     //
        incomingEdges = ((context.tokensByRecipient[grainId] || {})[vertexId.slice(2)] || []).map(tokenToEdge);        // 1081
      }                                                                                                                //
    } else {                                                                                                           //
      throw new Meteor.Error(500, "Unrecognized vertex ID: " + vertexId);                                              // 1085
    }                                                                                                                  //
                                                                                                                       //
    // For each edge incoming to this vertex, backpropagate this vertex's PermissionFlow to the                        //
    // source vertex, joining it with the edge's constraints.                                                          //
    incomingEdges.forEach(function (edge) {                                                                            // 1090
      var sharerId = edge.sharerId;                                                                                    // 1091
      if (edge.token) {                                                                                                // 1092
        if (!visitedTokensBySharerId[sharerId]) {                                                                      // 1093
          visitedTokensBySharerId[sharerId] = {};                                                                      // 1094
        }                                                                                                              //
                                                                                                                       //
        visitedTokensBySharerId[sharerId][edge.token._id] = edge.token;                                                // 1097
      }                                                                                                                //
                                                                                                                       //
      if (!visitedVertexIds[sharerId]) {                                                                               // 1100
        // Never saw this vertex before.                                                                               //
        visitedVertexIds[sharerId] = true;                                                                             // 1102
        vertexStack.push(sharerId);                                                                                    // 1103
      }                                                                                                                //
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  while (vertexStack.length > 0) {                                                                                     // 1034
    _loop2();                                                                                                          //
  }                                                                                                                    //
                                                                                                                       //
  // Now walk forward from the owner.                                                                                  //
  var relevantTokens = {};                                                                                             // 994
  var visitedSharers = {};                                                                                             // 1111
                                                                                                                       //
  var sharerStack = [];                                                                                                // 1113
  ownerIdentityIds.forEach(function (identityId) {                                                                     // 1114
    sharerStack.push("i:" + identityId);                                                                               // 1114
  });                                                                                                                  //
  while (sharerStack.length > 0) {                                                                                     // 1115
    var sharerId = sharerStack.pop();                                                                                  // 1116
    for (var tokenId in meteorBabelHelpers.sanitizeForInObject(visitedTokensBySharerId[sharerId])) {                   // 1117
      relevantTokens[tokenId] = true;                                                                                  // 1118
      var token = visitedTokensBySharerId[sharerId][tokenId];                                                          // 1119
      var recipientId = vertexIdOfTokenOwner(token);                                                                   // 1120
                                                                                                                       //
      if (!visitedSharers[recipientId]) {                                                                              // 1122
        visitedSharers[recipientId] = true;                                                                            // 1123
        sharerStack.push(recipientId);                                                                                 // 1124
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return {                                                                                                             // 1129
    tokenIds: Object.keys(relevantTokens),                                                                             // 1130
    ownerEdges: ownerEdges                                                                                             // 1131
  };                                                                                                                   //
}                                                                                                                      //
                                                                                                                       //
var vertexPattern = Match.OneOf({ token: Match.ObjectIncluding({ _id: String, grainId: String }) }, {                  // 1135
  grain: Match.ObjectIncluding({                                                                                       // 1138
    _id: String,                                                                                                       // 1139
    identityId: Match.OneOf(String, null, undefined)                                                                   // 1140
  })                                                                                                                   //
});                                                                                                                    //
// A vertex in the sharing graph is a principal, e.g. a user (identity) or a token. Complicating                       //
// matters, we may have to traverse sharing graphs for multiple grains in the same computation. A                      //
// token is specific to one grain, but a user of course can have access to multiple grains, so in                      //
// the case of a user we represent the vertex as a (user, grain) pair.                                                 //
//                                                                                                                     //
// TODO(cleanup): Perhaps `grain` should be renamed to `user` or `identity`? In the common case                        //
//   where only a single grain's shares need to be considered, it feels weird to think of the                          //
//   grain ID as being the primary distinguishing feature of the vertex.                                               //
                                                                                                                       //
SandstormPermissions.mayOpenGrain = function (db, vertex) {                                                            // 1153
  // Determines whether the vertex is allowed to open the grain. May make multiple database                            //
  // queries.                                                                                                          //
                                                                                                                       //
  check(vertex, vertexPattern);                                                                                        // 1157
  var grainId = vertex.token ? vertex.token.grainId : vertex.grain._id;                                                // 1158
  var vertexId = vertex.token ? "t:" + vertex.token._id : "i:" + vertex.grain.identityId;                              // 1159
  var context = new Context();                                                                                         // 1160
  var emptyPermissions = new PermissionSet([]);                                                                        // 1161
  return !!context.tryToProve(grainId, vertexId, emptyPermissions, db);                                                // 1162
};                                                                                                                     //
                                                                                                                       //
var CompoundObserveHandle = function () {                                                                              //
  function CompoundObserveHandle() {                                                                                   // 1166
    (0, _classCallCheck3["default"])(this, CompoundObserveHandle);                                                     //
                                                                                                                       //
    this._handles = [];                                                                                                // 1167
  }                                                                                                                    //
                                                                                                                       //
  CompoundObserveHandle.prototype.push = function () {                                                                 // 1165
    function push(handle) {                                                                                            //
      this._handles.push(handle);                                                                                      // 1171
    }                                                                                                                  //
                                                                                                                       //
    return push;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  CompoundObserveHandle.prototype.stop = function () {                                                                 // 1165
    function stop() {                                                                                                  //
      this._handles.forEach(function (handle) {                                                                        // 1175
        return handle.stop();                                                                                          //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return stop;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return CompoundObserveHandle;                                                                                        //
}();                                                                                                                   //
                                                                                                                       //
SandstormPermissions.grainPermissions = function (db, vertex, viewInfo, onInvalidated) {                               // 1179
  // Computes the set of permissions received by `vertex`. Returns an object with a                                    //
  // `permissions` field containing the computed permissions. If the field is null then                                //
  // the `vertex` does not even have the base "allowed to access at all" permission.                                   //
  //                                                                                                                   //
  // `onInvalidated` is an optional callback. If provided, it will be called when the result                           //
  // has been invalidated. If `onValidated` is provided, the result of `grainPermissions` will                         //
  // have a `observeHandle` field, containing an object with a `stop()` method that must be                            //
  // called once the computation becomes so longer relevant.                                                           //
                                                                                                                       //
  check(db, SandstormDb);                                                                                              // 1189
  check(vertex, vertexPattern);                                                                                        // 1190
  var grainId = vertex.token ? vertex.token.grainId : vertex.grain._id;                                                // 1191
  var vertexId = vertex.token ? "t:" + vertex.token._id : "i:" + vertex.grain.identityId;                              // 1192
                                                                                                                       //
  var resultPermissions = void 0;                                                                                      // 1194
  var observeHandle = void 0;                                                                                          // 1195
  var onInvalidatedActive = false;                                                                                     // 1196
                                                                                                                       //
  var startTime = new Date();                                                                                          // 1198
  function measureElapsedTime(result) {                                                                                // 1199
    var elapsedMilliseconds = new Date() - startTime;                                                                  // 1200
    if (elapsedMilliseconds > 200) {                                                                                   // 1201
      console.log("Warning: SandstormPermissions.grainPermissions() took " + elapsedMilliseconds + " milliseconds to complete for the vertex " + JSON.stringify(vertex));
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // Our computation proceeds in two phases. In the first, we determine which permissions the vertex                   //
  // appears to have and we compute set of tokens which appears to be sufficent to prove those                         //
  // permissions. However, concurrent database modifications may render the computation invalid, so                    //
  // in the second phases we verify that our proof is still valid and arrange for onInvalidated                        //
  // to be called when necessary. This is an optimisistic approach to concurrency. If the                              //
  // verification phase fails, we try again before giving up entirely.                                                 //
                                                                                                                       // 1179
  var _loop3 = function _loop3(attemptCount) {                                                                         //
    if (observeHandle) {                                                                                               // 1214
      observeHandle.stop();                                                                                            // 1215
      observeHandle = null;                                                                                            // 1216
    }                                                                                                                  //
                                                                                                                       //
    var context = new Context();                                                                                       // 1219
    var allPermissions = PermissionSet.fromRoleAssignment({ allAccess: null }, viewInfo);                              // 1220
    var firstPhasePermissions = context.tryToProve(grainId, vertexId, allPermissions, db);                             // 1221
                                                                                                                       //
    if (!firstPhasePermissions) return {                                                                               // 1223
        v: { permissions: null }                                                                                       //
      };                                                                                                               //
                                                                                                                       //
    var needed = context.getResponsibleTokens(grainId, vertexId);                                                      // 1225
    var neededTokens = needed.tokenIds;                                                                                // 1226
    var neededGrains = needed.grainIds;                                                                                // 1227
                                                                                                                       //
    // Phase 2: Now let's verify those permissions.                                                                    //
                                                                                                                       //
    context.reset();                                                                                                   // 1231
                                                                                                                       //
    var invalidated = false;                                                                                           // 1233
    function guardedOnInvalidated() {                                                                                  // 1234
      var shouldCall = onInvalidatedActive && !invalidated;                                                            // 1235
      invalidated = true;                                                                                              // 1236
      if (shouldCall) {                                                                                                // 1237
        onInvalidated();                                                                                               // 1238
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    var tokenCursor = db.collections.apiTokens.find({                                                                  // 1242
      _id: { $in: neededTokens },                                                                                      // 1243
      revoked: { $ne: true },                                                                                          // 1244
      objectId: { $exists: false }                                                                                     // 1245
    });                                                                                                                //
                                                                                                                       //
    if (onInvalidated) {                                                                                               // 1248
      observeHandle = new CompoundObserveHandle();                                                                     // 1249
      observeHandle.push(tokenCursor.observe({                                                                         // 1250
        changed: function () {                                                                                         // 1251
          function changed(newApiToken, oldApiToken) {                                                                 //
            if (newApiToken.trashed || !_.isEqual(newApiToken.roleAssignment, oldApiToken.roleAssignment) || !_.isEqual(newApiToken.revoked, oldApiToken.revoked)) {
              observeHandle.stop();                                                                                    // 1255
              guardedOnInvalidated();                                                                                  // 1256
            }                                                                                                          //
          }                                                                                                            //
                                                                                                                       //
          return changed;                                                                                              //
        }(),                                                                                                           //
        removed: function () {                                                                                         // 1260
          function removed(oldApiToken) {                                                                              //
            observeHandle.stop();                                                                                      // 1261
            guardedOnInvalidated();                                                                                    // 1262
          }                                                                                                            //
                                                                                                                       //
          return removed;                                                                                              //
        }()                                                                                                            //
      }));                                                                                                             //
                                                                                                                       //
      var grainCursor = db.collections.grains.find({ _id: { $in: neededGrains } });                                    // 1266
      observeHandle.push(grainCursor.observe({                                                                         // 1267
        changed: function () {                                                                                         // 1268
          function changed(newGrain, oldGrain) {                                                                       //
            if (newGrain.trashed || !oldGrain["private"] && newGrain["private"]) {                                     // 1269
              observeHandle.stop();                                                                                    // 1272
              guardedOnInvalidated();                                                                                  // 1273
            }                                                                                                          //
          }                                                                                                            //
                                                                                                                       //
          return changed;                                                                                              //
        }(),                                                                                                           //
        removed: function () {                                                                                         // 1277
          function removed(oldGrain) {                                                                                 //
            observeHandle.stop();                                                                                      // 1278
            guardedOnInvalidated();                                                                                    // 1279
          }                                                                                                            //
                                                                                                                       //
          return removed;                                                                                              //
        }()                                                                                                            //
      }));                                                                                                             //
    }                                                                                                                  //
                                                                                                                       //
    context.addTokensFromCursor(tokenCursor);                                                                          // 1284
                                                                                                                       //
    // TODO(someday): Also account for linking/unlinking of identities and accounts losing admin                       //
    //   privileges. Currently we do not call `onInvalided()` on such events. We would need to set                     //
    //   up more cursor observers.                                                                                     //
                                                                                                                       //
    resultPermissions = context.tryToProve(grainId, vertexId, firstPhasePermissions);                                  // 1290
                                                                                                                       //
    if (resultPermissions && firstPhasePermissions.isSubsetOf(resultPermissions)) {                                    // 1292
      // We've confirmed the permissions that we found the in the first phase. Done!                                   //
      return "break";                                                                                                  // 1294
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  _loop4: for (var attemptCount = 0; attemptCount < 3; ++attemptCount) {                                               //
    var _ret5 = _loop3(attemptCount);                                                                                  //
                                                                                                                       //
    switch (_ret5) {                                                                                                   //
      case "break":                                                                                                    //
        break _loop4;                                                                                                  // 1294
                                                                                                                       //
      default:                                                                                                         //
        if ((typeof _ret5 === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret5)) === "object") return _ret5.v;
    }                                                                                                                  //
  } // for (let attemptCount ...) {                                                                                    //
                                                                                                                       //
  onInvalidatedActive = true;                                                                                          // 1179
  var result = {};                                                                                                     // 1299
  if (resultPermissions) result.permissions = resultPermissions.array;                                                 // 1300
  if (observeHandle) result.observeHandle = observeHandle;                                                             // 1301
  measureElapsedTime();                                                                                                // 1302
  return result;                                                                                                       // 1303
};                                                                                                                     //
                                                                                                                       //
SandstormPermissions.downstreamTokens = function (db, root) {                                                          // 1306
  // Computes a list of the UiView tokens that are downstream in the sharing graph from a given                        //
  // source. The source, `root`, can either be a token or a (grain, user) pair. The exact format                       //
  // of `root` is specified in the `check()` invocation below.                                                         //
  //                                                                                                                   //
  // TODO(someday): Account for membrane requirements in this computation.                                             //
                                                                                                                       //
  check(root, Match.OneOf({ token: Match.ObjectIncluding({ _id: String, grainId: String }) }, { grain: Match.ObjectIncluding({ _id: String, identityId: String }) }));
                                                                                                                       //
  var result = [];                                                                                                     // 1316
  var tokenStack = [];                                                                                                 // 1317
  var stackedTokens = {};                                                                                              // 1318
  var tokensBySharer = {};                                                                                             // 1319
  var tokensByParent = {};                                                                                             // 1320
  var tokensById = {};                                                                                                 // 1321
                                                                                                                       //
  function addChildren(tokenId) {                                                                                      // 1323
    var children = tokensByParent[tokenId];                                                                            // 1324
    if (children) {                                                                                                    // 1325
      children.forEach(function (child) {                                                                              // 1326
        if (!stackedTokens[child._id]) {                                                                               // 1327
          tokenStack.push(child);                                                                                      // 1328
          stackedTokens[child._id] = true;                                                                             // 1329
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  function addSharedTokens(sharer) {                                                                                   // 1335
    var sharedTokens = tokensBySharer[sharer];                                                                         // 1336
    if (sharedTokens) {                                                                                                // 1337
      sharedTokens.forEach(function (sharedToken) {                                                                    // 1338
        if (!stackedTokens[sharedToken._id]) {                                                                         // 1339
          tokenStack.push(sharedToken);                                                                                // 1340
          stackedTokens[sharedToken._id] = true;                                                                       // 1341
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  var grainId = root.token ? root.token.grainId : root.grain._id;                                                      // 1347
  var grain = db.getGrain(grainId);                                                                                    // 1348
  if (!grain || !grain["private"]) {                                                                                   // 1349
    return result;                                                                                                     // 1349
  }                                                                                                                    //
                                                                                                                       //
  db.collections.apiTokens.find({ grainId: grainId,                                                                    // 1351
    revoked: { $ne: true } }).forEach(function (token) {                                                               // 1352
    tokensById[token._id] = token;                                                                                     // 1353
    if (token.parentToken) {                                                                                           // 1354
      if (!tokensByParent[token.parentToken]) {                                                                        // 1355
        tokensByParent[token.parentToken] = [];                                                                        // 1356
      }                                                                                                                //
                                                                                                                       //
      tokensByParent[token.parentToken].push(token);                                                                   // 1359
    } else if (token.identityId) {                                                                                     //
      if (!tokensBySharer[token.identityId]) {                                                                         // 1361
        tokensBySharer[token.identityId] = [];                                                                         // 1362
      }                                                                                                                //
                                                                                                                       //
      tokensBySharer[token.identityId].push(token);                                                                    // 1365
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  if (root.token) {                                                                                                    // 1369
    addChildren(root.token._id);                                                                                       // 1370
  } else if (root.grain) {                                                                                             //
    addSharedTokens(root.grain.identityId);                                                                            // 1372
  }                                                                                                                    //
                                                                                                                       //
  while (tokenStack.length > 0) {                                                                                      // 1375
    var token = tokenStack.pop();                                                                                      // 1376
    result.push(token);                                                                                                // 1377
    addChildren(token._id);                                                                                            // 1378
    if (token.owner && token.owner.user) {                                                                             // 1379
      addSharedTokens(token.owner.user.identityId);                                                                    // 1380
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return result;                                                                                                       // 1384
};                                                                                                                     //
                                                                                                                       //
var HeaderSafeString = Match.Where(function (str) {                                                                    // 1387
  check(str, String);                                                                                                  // 1388
  return str.match(/^[\x20-\x7E]*$/);                                                                                  // 1389
});                                                                                                                    //
                                                                                                                       //
var DavClass = Match.Where(function (str) {                                                                            // 1392
  check(str, String);                                                                                                  // 1393
  return str.match(/^[a-zA-Z0-9!#$%&'*+.^_`|~-]+$/) || str.match(/^<[\x21-\x7E]*>$/); // supposed to be a URL          // 1394
});                                                                                                                    // 1392
                                                                                                                       //
var ResourceMap = Match.Where(function (map) {                                                                         // 1398
  for (path in meteorBabelHelpers.sanitizeForInObject(map)) {                                                          // 1399
    if (!path.match(/^\/[\x21-\x7E]*$/)) {                                                                             // 1400
      return false;                                                                                                    // 1401
    }                                                                                                                  //
                                                                                                                       //
    check(map[path], {                                                                                                 // 1404
      type: HeaderSafeString,                                                                                          // 1405
      language: Match.Optional(HeaderSafeString),                                                                      // 1406
      encoding: Match.Optional(HeaderSafeString),                                                                      // 1407
      body: String                                                                                                     // 1408
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  return true;                                                                                                         // 1412
});                                                                                                                    //
                                                                                                                       //
var LocalizedString = {                                                                                                // 1415
  defaultText: String,                                                                                                 // 1416
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 1417
};                                                                                                                     //
                                                                                                                       //
SandstormPermissions.createNewApiToken = function (db, provider, grainId, petname, roleAssignment, owner, unauthenticated) {
  // Creates a new UiView API token. If `rawParentToken` is set, creates a child token.                                //
  check(grainId, String);                                                                                              // 1425
  check(petname, String);                                                                                              // 1426
  check(roleAssignment, db.roleAssignmentPattern);                                                                     // 1427
  // Meteor bug #3877: we get null here instead of undefined when we                                                   //
  // explicitly pass in undefined.                                                                                     //
  check(provider, Match.OneOf({ identityId: String, accountId: String }, { rawParentToken: Match.OneOf(String, Buffer) }));
  check(owner, Match.OneOf({                                                                                           // 1432
    webkey: Match.OneOf(null, {                                                                                        // 1433
      forSharing: Boolean,                                                                                             // 1434
      expiresIfUnusedDuration: Match.Optional(Number)                                                                  // 1435
    })                                                                                                                 //
  }, {                                                                                                                 //
    user: {                                                                                                            // 1438
      identityId: String,                                                                                              // 1439
      title: String,                                                                                                   // 1440
      renamed: Match.Optional(Boolean),                                                                                // 1441
      upstreamTitle: Match.Optional(String)                                                                            // 1442
    }                                                                                                                  //
  }, {                                                                                                                 //
    grain: {                                                                                                           // 1445
      grainId: String,                                                                                                 // 1446
      saveLabel: LocalizedString,                                                                                      // 1447
      introducerIdentity: String                                                                                       // 1448
    }                                                                                                                  //
  }, {                                                                                                                 //
    frontend: null                                                                                                     // 1451
  }));                                                                                                                 //
                                                                                                                       //
  check(unauthenticated, Match.OneOf(undefined, null, {                                                                // 1454
    options: Match.Optional({ dav: [Match.Optional(DavClass)] }),                                                      // 1455
    resources: Match.Optional(ResourceMap)                                                                             // 1456
  }));                                                                                                                 //
                                                                                                                       //
  if (unauthenticated && JSON.stringify(unauthenticated).length > 4096) {                                              // 1459
    throw new Meteor.Error(400, "Unauthenticated params too large; limit 4kb.");                                       // 1460
  }                                                                                                                    //
                                                                                                                       //
  var grain = db.getGrain(grainId);                                                                                    // 1463
  if (!grain) {                                                                                                        // 1464
    throw new Meteor.Error(403, "Unauthorized", "No grain found.");                                                    // 1465
  }                                                                                                                    //
                                                                                                                       //
  var token = Random.secret();                                                                                         // 1468
  var apiToken = {                                                                                                     // 1469
    _id: Crypto.createHash("sha256").update(token).digest("base64"),                                                   // 1470
    grainId: grainId,                                                                                                  // 1471
    roleAssignment: roleAssignment,                                                                                    // 1472
    petname: petname,                                                                                                  // 1473
    created: new Date(),                                                                                               // 1474
    expires: null                                                                                                      // 1475
  };                                                                                                                   //
                                                                                                                       //
  var result = {};                                                                                                     // 1478
  var parentForSharing = false;                                                                                        // 1479
  if (provider.rawParentToken) {                                                                                       // 1480
    var parentToken = Crypto.createHash("sha256").update(provider.rawParentToken).digest("base64");                    // 1481
    var parentApiToken = db.collections.apiTokens.findOne({ _id: parentToken, grainId: grainId, objectId: { $exists: false } });
    if (!parentApiToken) {                                                                                             // 1484
      throw new Meteor.Error(403, "No such parent token found.");                                                      // 1485
    }                                                                                                                  //
                                                                                                                       //
    if (parentApiToken.forSharing) {                                                                                   // 1488
      parentForSharing = true;                                                                                         // 1489
    }                                                                                                                  //
                                                                                                                       //
    apiToken.identityId = parentApiToken.identityId;                                                                   // 1492
    apiToken.accountId = parentApiToken.accountId;                                                                     // 1493
                                                                                                                       //
    apiToken.parentToken = parentToken;                                                                                // 1495
    result.parentApiToken = parentApiToken;                                                                            // 1496
  } else if (provider.identityId) {                                                                                    //
    apiToken.identityId = provider.identityId;                                                                         // 1498
    apiToken.accountId = provider.accountId;                                                                           // 1499
  }                                                                                                                    //
                                                                                                                       //
  if (owner.webkey) {                                                                                                  // 1502
    // Non-null webkey is a special case not covered in ApiTokenOwner.                                                 //
    // TODO(cleanup): Maybe ApiTokenOwner.webkey should be extended with these fields?                                 //
    apiToken.owner = { webkey: null };                                                                                 // 1505
    apiToken.forSharing = parentForSharing || owner.webkey.forSharing;                                                 // 1506
    if (owner.webkey.expiresIfUnusedDuration) {                                                                        // 1507
      apiToken.expiresIfUnused = new Date(Date.now() + owner.webkey.expiresIfUnusedDuration);                          // 1508
    }                                                                                                                  //
  } else if (owner.user) {                                                                                             //
    var grainInfo = db.getDenormalizedGrainInfo(grainId);                                                              // 1511
    apiToken.owner = {                                                                                                 // 1512
      user: {                                                                                                          // 1513
        identityId: owner.user.identityId,                                                                             // 1514
        title: owner.user.title,                                                                                       // 1515
        denormalizedGrainMetadata: grainInfo                                                                           // 1516
      }                                                                                                                //
    };                                                                                                                 //
                                                                                                                       //
    if (grain.title !== owner.user.title) {                                                                            // 1520
      apiToken.owner.user.upstreamTitle = grain.title;                                                                 // 1521
    }                                                                                                                  //
  } else {                                                                                                             //
    // Note: Also covers the case of `webkey: null`.                                                                   //
    apiToken.owner = owner;                                                                                            // 1525
  }                                                                                                                    //
                                                                                                                       //
  if (unauthenticated) {                                                                                               // 1528
    var apiHost = {                                                                                                    // 1529
      _id: db.apiHostIdHashForToken(token),                                                                            // 1530
      hash2: Crypto.createHash("sha256").update(apiToken._id).digest("base64")                                         // 1531
    };                                                                                                                 //
    if (unauthenticated.options) {                                                                                     // 1533
      apiHost.options = unauthenticated.options;                                                                       // 1534
    }                                                                                                                  //
                                                                                                                       //
    if (unauthenticated.resources) {                                                                                   // 1537
      // Mongo requires keys in objects to be escaped. Ugh.                                                            //
      apiHost.resources = {};                                                                                          // 1539
      for (var key in meteorBabelHelpers.sanitizeForInObject(unauthenticated.resources)) {                             // 1540
        apiHost.resources[SandstormDb.escapeMongoKey(key)] = unauthenticated.resources[key];                           // 1541
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    db.collections.apiHosts.insert(apiHost);                                                                           // 1545
    apiToken.hasApiHost = true;                                                                                        // 1546
  }                                                                                                                    //
                                                                                                                       //
  db.collections.apiTokens.insert(apiToken);                                                                           // 1549
                                                                                                                       //
  result.id = apiToken._id;                                                                                            // 1551
  result.token = token;                                                                                                // 1552
  return result;                                                                                                       // 1553
};                                                                                                                     //
                                                                                                                       //
// Make self-destructing tokens actually self-destruct, so they don't                                                  //
// clutter the token list view.                                                                                        //
SandstormPermissions.cleanupSelfDestructing = function (db) {                                                          // 1558
  return function () {                                                                                                 // 1559
    var now = new Date();                                                                                              // 1560
    db.removeApiTokens({ expiresIfUnused: { $lt: now } });                                                             // 1561
  };                                                                                                                   //
};                                                                                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 1565
  transitiveShares: function () {                                                                                      // 1566
    function transitiveShares(identityId, grainId) {                                                                   // 1566
      check(identityId, String);                                                                                       // 1567
      check(grainId, String);                                                                                          // 1568
      if (this.userId) {                                                                                               // 1569
        var db = this.connection.sandstormDb;                                                                          // 1570
        return SandstormPermissions.downstreamTokens(db, { grain: { _id: grainId, identityId: identityId } });         // 1571
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return transitiveShares;                                                                                           //
  }(),                                                                                                                 //
                                                                                                                       //
  newApiToken: function () {                                                                                           // 1576
    function newApiToken(provider, grainId, petname, roleAssignment, owner, unauthenticated) {                         // 1576
      check(provider, Match.OneOf({ identityId: String }, { rawParentToken: String }));                                // 1577
      // other check()s happen in SandstormPermissions.createNewApiToken().                                            //
      var db = this.connection.sandstormDb;                                                                            // 1576
      if (provider.identityId) {                                                                                       // 1580
        if (!this.userId || !db.userHasIdentity(this.userId, provider.identityId)) {                                   // 1581
          throw new Meteor.Error(403, "Not an identity of the current user: " + provider.identityId);                  // 1582
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      if (provider.identityId) {                                                                                       // 1586
        provider.accountId = this.userId;                                                                              // 1587
      }                                                                                                                //
                                                                                                                       //
      return SandstormPermissions.createNewApiToken(this.connection.sandstormDb, provider, grainId, petname, roleAssignment, owner, unauthenticated);
    }                                                                                                                  //
                                                                                                                       //
    return newApiToken;                                                                                                //
  }(),                                                                                                                 //
                                                                                                                       //
  updateApiToken: function () {                                                                                        // 1595
    function updateApiToken(token, newFields) {                                                                        // 1595
      var db = this.connection.sandstormDb;                                                                            // 1596
                                                                                                                       //
      check(token, String);                                                                                            // 1598
      check(newFields, { petname: Match.Optional(String),                                                              // 1599
        roleAssignment: Match.Optional(db.roleAssignmentPattern),                                                      // 1600
        revoked: Match.Optional(Boolean) });                                                                           // 1601
                                                                                                                       //
      if (!this.userId) {                                                                                              // 1603
        throw new Meteor.Error(403, "Must be logged in to modify a token");                                            // 1604
      }                                                                                                                //
                                                                                                                       //
      var apiToken = db.collections.apiTokens.findOne(token);                                                          // 1607
      if (!apiToken) {                                                                                                 // 1608
        throw new Meteor.Error(404, "No such token found.");                                                           // 1609
      }                                                                                                                //
                                                                                                                       //
      if (db.userHasIdentity(this.userId, apiToken.identityId)) {                                                      // 1612
        var modifier = { $set: newFields };                                                                            // 1613
        db.collections.apiTokens.update(token, modifier);                                                              // 1614
      } else {                                                                                                         //
        throw new Meteor.Error(403, "User not authorized to modify this token.");                                      // 1616
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return updateApiToken;                                                                                             //
  }()                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-permissions/permissions.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-permissions'] = {}, {
  SandstormPermissions: SandstormPermissions
});

})();

//# sourceMappingURL=sandstorm-permissions.js.map
